c
c --------------------------------------------------------------
c
      subroutine cent2d(p,xc,yc,area)
      implicit double precision (a-h,o-z)
      dimension p(20,2)
      dimension xcen(20),ycen(20),subar(20)
c
c     # Compute the centroid (xc,yc) of the polygon p.
c     # Also returns the area.
c
      do i=3,20
	 if (p(i+1,1) .eq. -99.d0) then
	     if (i .eq. 3) then
	        write(6,*) 'degenerate polygon in cent2d'
	        go to 109
	     endif
	     go to 200
	 endif
c
c        # Compute centroid of triangle with vertices 1, i-1, and i
         xcen(i) = (p(i-1,1)+p(i,1)+p(1,1))/3.d0
         ycen(i) = (p(i-1,2)+p(i,2)+p(1,2))/3.d0
c
c        # compute area: (twice of the actual area)
         subar(i) = (p(1,2)+p(i-1,2))*(p(i-1,1)-p(1,1))+
     &              (p(i-1,2)+p(i,2))*(p(i,1)-p(i-1,1))+
     &              (p(i,2)+p(1,2))*(p(1,1)-p(i,1))
         enddo
c
      write(6,*) 'error in cent2d: too many vertices'
 109  continue
      do ii=1,20
         if (p(ii,1) .eq. -99.d0) go to 119
         write(6,*) p(ii,1),p(ii,2)
         enddo
 119  continue
      stop
c
 200  continue
c     # take weighted average of triangle centroids to find 
c     # centroid of polygon:
      area = 0.d0
      xc = 0.d0
      yc = 0.d0
      do j=3,i-1
	 area = area+subar(j)
	 xc = xc+subar(j)*xcen(j)
	 yc = yc+subar(j)*ycen(j)
         enddo
c
      if (0.5d0*dabs(area) .le. 1.d-15) area = 0.d0
c
      if (area .eq. 0.d0) then
	  xc = p(1,1)
	  yc = p(1,2)
      else
          xc = xc/area
          yc = yc/area
      endif
      area = 0.5d0*dabs(area)
c
      return
      end
