c
c --------------------------------------------------------------
c
      subroutine ctoprm(q,rho,u,v,rhoe,rhok,p,gamma,gruen,
     &                  gam0,alp0,bet0,pn0,psi0)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /fluid/ geos(maxfr),alp(maxfr),bet(maxfr),pnf(maxfr),
     &               zf(maxfr),psi(maxfr),mphase  
      dimension q(20)
c
c     # change conservative variables to primitive variables
c
      rho = q(1)
      u   = q(2)/q(1)
      v   = q(3)/q(1)
c
      go to (1,2,3,4) mphase
c
 1    continue
c     # gamma-based version
c
      gam0 = (1.d0+q(5))/q(5)
      rhob = q(6)/q(5)
      gamma = gam0/(1.d0-rhob)
      bet0 = rhob/rho
      pn0  = q(7)/(1.d0+q(5)-q(6))
      alp0 = q(9)
      gruen = 1.d0/(q(5)-q(6))
      psi0 = q(10)
      rhok = .5d0*(q(2)*q(2)+q(3)*q(3))/q(1)
      rhoe = q(4)-rhok 
      p = gruen*(rhoe-q(7)-q(8))
      return
c
 2    continue
c     # gamma-based version
c     # include total kinetic energy
c
      gam0 = (1.d0+q(5))/q(5)
      rhob = q(6)/q(5)
      gamma = gam0/(1.d0-rhob)
      bet0 = rhob/rho
      pn0  = q(7)/(1.d0+q(5)-q(6))
      alp0 = q(9)
      gruen = 1.d0/(q(5)-q(6))
c
      psi0 = q(11)
      rhok = q(10)
      rhoe = q(4)-rhok
      p = gruen*(rhoe-q(7)-q(8))
      return 
c
 3    continue
c     # gamma-based version
c     # version II
c
      gam0 = (1.d0+q(5))/q(5)
      rhob = q(6)/q(5)
      gamma = gam0/(1.d0-rhob)
      bet0 = rhob/rho
      alp0 = q(8)
      pn0  = q(9)
      gruen = 1.d0/(q(5)-q(6))
      psi0 = q(10)
      rhok = .5d0*(q(2)*q(2)+q(3)*q(3))/q(1)
      rhoe = q(4)-rhok 
      p = gruen*(rhoe-q(7))
      return
c
 4    continue
c     # gamma-based version
c     # include total kinetic energy
c     # version II
c
      gam0 = (1.d0+q(5))/q(5)
      rhob = q(6)/q(5)
      gamma = gam0/(1.d0-rhob)
      bet0 = rhob/rho
      alp0 = q(8)
      pn0 = q(9)
      gruen = 1.d0/(q(5)-q(6))
c
      psi0 = q(11)
      rhok = q(10)
      rhoe = q(4)-rhok
      p = gruen*(rhoe-q(7))
      return          
c
      end
