c
c ---------------------------------------------------------------
c
      subroutine edgcel(xlow,ylow,hx,hy,lstold)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkedge/ iedge(4,maxbd),iecell(4,6,maxbd),
     &                edgp(2,2,4,6,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension p1(20,2)
c
c     # set edge-cell relation
c
      iptr = lstold
      do ik=1,maxbd
         iptr = iabs(nxtirr(iptr))
         if (iptr .eq. 0) go to 199
         ix = ixc(iptr)
         jy = jyc(iptr)
c
          xi = xlow+dfloat(ix-1)*hx
          yj = ylow+dfloat(jy-1)*hy
          p1(1,1) = xi
          p1(1,2) = yj
          p1(2,1) = xi
          p1(2,2) = yj+hy
          p1(3,1) = xi+hx
          p1(3,2) = yj+hy
          p1(4,1) = xi+hx
          p1(4,2) = yj
          p1(5,1) = xi
          p1(5,2) = yj
          p1(6,1) = -99.d0
          p1(6,2) = -99.d0 
c
c        # initialize basic edge info
         do iside=1,4
            iedge(iside,iptr) = 1
            enddo
c
c        # left edge
         edgp(1,1,1,1,iptr) = p1(1,1)
         edgp(1,2,1,1,iptr) = p1(1,2)  
         edgp(2,1,1,1,iptr) = p1(2,1)
         edgp(2,2,1,1,iptr) = p1(2,2)
c
c        # top edge
         edgp(1,1,2,1,iptr) = p1(2,1)  
         edgp(1,2,2,1,iptr) = p1(2,2)    
         edgp(2,1,2,1,iptr) = p1(3,1)     
         edgp(2,2,2,1,iptr) = p1(3,2)    
c
c        # right edge
         edgp(1,1,3,1,iptr) = p1(4,1)
         edgp(1,2,3,1,iptr) = p1(4,2)   
         edgp(2,1,3,1,iptr) = p1(3,1)    
         edgp(2,2,3,1,iptr) = p1(3,2)
c
c        # bottom edge
         edgp(1,1,4,1,iptr) = p1(1,1)  
         edgp(1,2,4,1,iptr) = p1(1,2)  
         edgp(2,1,4,1,iptr) = p1(4,1)    
         edgp(2,2,4,1,iptr) = p1(4,2)  
c
c        # insert points in edge
         do ibd=1,nbonds(iptr)
            kbond = nbondc(ibd,iptr)
            do 10 ip=1,2
               x0 = points(ip,1,kbond)
               y0 = points(ip,2,kbond)
c
               do iside=1,4
                  x1 = p1(iside,1)
                  y1 = p1(iside,2)
                  x2 = p1(iside+1,1)
                  y2 = p1(iside+1,2)
c
c                 # in between ?
                  if (dabs(area2(x1,y1,x2,y2,x0,y0)) .lt.
     &                1.d-10) then
                      do ie=1,iedge(iside,iptr)
                         x1 = edgp(1,1,iside,ie,iptr)
                         y1 = edgp(1,2,iside,ie,iptr)
                         x2 = edgp(2,1,iside,ie,iptr)
                         y2 = edgp(2,2,iside,ie,iptr)
c
c                        # insert point
                         if ((iside .eq. 1) .or. 
     &                       (iside .eq. 3)) then
c                            # vertical edge
                             if ((y0-y1)*(y0-y2) .lt. 0.d0) then
                                 do ie0=ie+1,iedge(iside,iptr)
                                    do ip0=1,2
                                       edgp(1,ip0,iside,ie0+1,iptr) = 
     &                                      edgp(1,ip0,iside,ie0,iptr) 
c
                                       edgp(2,ip0,iside,ie0+1,iptr) = 
     &                                      edgp(2,ip0,iside,ie0,iptr) 
                                       enddo
                                    enddo
c
                                 edgp(2,2,iside,ie,iptr) = y0
                                 edgp(1,1,iside,ie+1,iptr) = x0
                                 edgp(1,2,iside,ie+1,iptr) = y0
                                 edgp(2,1,iside,ie+1,iptr) = x2
                                 edgp(2,2,iside,ie+1,iptr) = y2
c
                                 iedge(iside,iptr) = iedge(iside,iptr)+1
                                 go to 10
                             endif
                         else
c                            # horizontal edge
                             if ((x0-x1)*(x0-x2) .lt. 0.d0) then
                                 do ie0=ie+1,iedge(iside,iptr)
                                    do ip0=1,2
                                       edgp(1,ip0,iside,ie0+1,iptr) =
     &                                      edgp(1,ip0,iside,ie0,iptr)
c
                                       edgp(2,ip0,iside,ie0+1,iptr) =
     &                                      edgp(2,ip0,iside,ie0,iptr)
                                       enddo
                                    enddo
c
                                 edgp(2,1,iside,ie,iptr) = x0
                                 edgp(1,1,iside,ie+1,iptr) = x0
                                 edgp(1,2,iside,ie+1,iptr) = y0
                                 edgp(2,1,iside,ie+1,iptr) = x2
                                 edgp(2,2,iside,ie+1,iptr) = y2
c
                                 iedge(iside,iptr) = iedge(iside,iptr)+1
                                 go to 10
                             endif
                         endif
                         enddo 
                  endif
                  enddo
 10            continue
            enddo
c
c        # set edge-cell relation
         if (nbonds(iptr) .eq. 1) then
c            # single bond case
             kbond = nbondc(1,iptr)
             x1 = points(1,1,kbond)
             y1 = points(1,2,kbond)
             x2 = points(2,1,kbond)
             y2 = points(2,2,kbond)
c
             do iside=1,4
                do ie=1,iedge(iside,iptr)
                   x0 = .5d0*(edgp(1,1,iside,ie,iptr)+
     &                   edgp(2,1,iside,ie,iptr))
                   y0 = .5d0*(edgp(1,2,iside,ie,iptr)+
     &                   edgp(2,2,iside,ie,iptr))
                   if (area2(x1,y1,x2,y2,x0,y0) .lt. 0.d0) then
c                      # post-shock subcell
                       iecell(iside,ie,iptr) = irrcell(1,kbond)
                   else
c                      # pre-shock subcell
                       iecell(iside,ie,iptr) = irrcell(2,kbond)
                   endif
                   enddo
                enddo
         else
c            # multiple bond case
             do iside=1,4
                do 25 ie=1,iedge(iside,iptr)
                   x1 = edgp(1,1,iside,ie,iptr)
                   y1 = edgp(1,2,iside,ie,iptr)
                   x2 = edgp(2,1,iside,ie,iptr)
                   y2 = edgp(2,2,iside,ie,iptr)
c
                   do 20 ic=1,ncells(iptr)
                      do ii=1,10
                         if (poly(ic,ii+1,1,iptr) .eq. -99.d0) go to 20
                         iscell = icheck(x1,y1,x2,y2,
     &                                   poly(ic,ii,1,iptr),
     &                                   poly(ic,ii,2,iptr),
     &                                   poly(ic,ii+1,1,iptr),
     &                                   poly(ic,ii+1,2,iptr))
                         if (iscell .eq. 1) then
                             iecell(iside,ie,iptr) = ic
                             go to 25
                         endif
                         enddo
 20                   continue
 25                continue
                enddo
         endif
         enddo
 199  continue
c
      return
      end
