c
c ---------------------------------------------------------------
c
      subroutine extirr(q,vof,irr,rwork,mitot,mjtot,meqn,lstgrd,work)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension q(mitot,mjtot,meqn),vof(mitot,mjtot),
     &          irr(mitot,mjtot),rwork(6*maxbd,meqn),work(meqn)
c
c     # correct irregular cell values by interpolating states over
c     # neighboring cells
c     # volume-of-fluid approach
c
      area0 = ar(1,lstgrd)
c
      nelm = 0
      iptr = lstgrd
      do ik=1,maxbd
         iptr = iabs(nxtirr(iptr))
         if (iptr .eq. 0) go to 199
         i = ix(iptr)
         j = jy(iptr)
c
         do icell=1,ncells(iptr)
            vof0 = vofir(icell,iptr)
c
            area = 0.d0
            do m=1,meqn
               work(m) = 0.d0
               enddo
c
            do iex=i-1,i+1
               do jex=j-1,j+1
                  if ((iex .eq. i) .and. (jex .eq. j)) go to 99
                  if (iabs(irr(iex,jex)) .ne. lstgrd) then
c                     # irregular cell case
                      iptr1 = irr(iex,jex)
c
                      do icel=1,ncells(iptr1)
                         vof1 = vofir(icel,iptr1)
                         if (dabs(vof1-vof0) .lt. 1.d-8) then
                             area = area+ar(icel,iptr1)
                             do m=1,meqn
                                work(m) = work(m)+
     &                          ar(icel,iptr1)*qirr(icel,m,iptr1)
                                enddo
                         endif 
                         enddo
                  else
c                     # regular cell case
                      vof1 = vof(iex,jex)
c
                      if (dabs(vof1-vof0) .lt. 1.d-8) then
                          area = area+area0
                          do m=1,meqn
                             work(m) = work(m)+area0*q(iex,jex,m)
                             enddo
                      endif
                  endif
 99               continue
                  enddo
               enddo
c
            if (area .ne. 0.d0) then
                do m=1,meqn
                   work(m) = work(m)/area
                   enddo
c
                vof0 = ar(icell,iptr)/area0
                vof1 = 1.d0-vof0
                do m=1,meqn
                   rwork(nelm+1,m) = vof1*work(m)+
     &                               vof0*qirr(icell,m,iptr)
                   enddo
            else
                do m=1,meqn
                   rwork(nelm+1,m) = qirr(icell,m,iptr)
                   enddo
            endif
c
            nelm = nelm+1
            enddo
         enddo
 199  continue
c
      nelm = 0
      iptr = lstgrd
      do ik=1,maxbd
         iptr = iabs(nxtirr(iptr))
         if (iptr .eq. 0) go to 299
         do icell=1,ncells(iptr)
c            write(6,*) 'old state'
c            write(6,1001) (qirr(icell,m,iptr),m=1,meqn)
c            write(6,*) 'new state'
c            write(6,1001) (rwork(nelm+1,m),m=1,meqn)
c
            do m=1,meqn
               qirr(icell,m,iptr) = rwork(nelm+1,m)
               enddo

            nelm = nelm+1
            enddo
         enddo
 299  continue 
c
 1001 format(5(f24.10,x))
      return
      end
