c
c ------------------------------------------------------------------------------
c
      double precision function fintf(x,y)
      implicit double precision (a-h,o-z)
      common /intf0/ posn(2),dir(2),r0,icase
      common /perturb/ amp(30),wvnb(30),wvlen(30),phase(30),modes
      common /mathc/ pi
c
c     # for computing cell averages for initial data that has a
c     # discontinuity along some curve.  fintf should be negative to the 
c     # left of the curve and positive to the right
c
      go to (1,2,3,4,5,6,7) icase
c
 1    continue
c     # straight line through (posn(1),posn(2)) with normal (dir(1),dir(2)) 
      fintf = (x-posn(1))*dir(1)+(y-posn(2))*dir(2)
      return
c
 2    continue
c     # sine curve in y
      fintf = x-posn(1)
      do mode=1,modes
         fintf = fintf-(amp(mode)*dsin(wvnb(mode)*y/
     &                    wvlen(mode)+phase(mode)))
         enddo
      return
c
 3    continue
c     # sine curve in x
      fintf = y-posn(2)
      do mode=1,modes
         fintf = fintf-(amp(mode)*dsin(wvnb(mode)*x/
     &                    wvlen(mode)+phase(mode)))
         enddo
      return
c
 4    continue
c     # ellipse
      theta = r0
      alf  = dcos(theta*pi/180.d0)
      beta = dsin(theta*pi/180.d0)
      xi  = alf*(x-posn(1))+beta*(y-posn(2))
      eta = -beta*(x-posn(1))+alf*(y-posn(2))
      fintf = (xi/dir(1))**2+
     &         (eta/dir(2))**2-1.d0
      return
c
 5    continue
c     # star-shape: close loop (0 <= theta <= 2) 
c     # point outward
      call polar(r,theta,x,y,posn(1),posn(2))
      ss = 1.d0-0.5d0*theta
      rs = r0
      do mode=1,modes
         rs = rs+(amp(mode)*dsin(wvnb(mode)*ss/
     &                    wvlen(mode)+phase(mode)))
         enddo
      fintf = r**2-rs**2
      return
c
 6    continue
c     # star-shape: close loop (0 <= theta <= 2)
c     # point inward
      call polar(r,theta,x,y,posn(1),posn(2))
      ss = 0.5d0*theta
      rs = r0
      do mode=1,modes
         rs = rs+(amp(mode)*dsin(wvnb(mode)*ss/
     &                    wvlen(mode)+phase(mode)))
         enddo
      fintf = rs**2-r**2
      return
c
 7    continue
c     # wound spiral
      call polar(r,theta,x,y,posn(1),posn(2))
      ss = 1.d0-0.5d0*theta
      rs = r0
c
      xs = posn(1)+amp(1)*dcos(wvnb(mode)*ss)
      ys = posn(2)+5.d0*amp(1)*dsin(wvnb(mode)*ss)
      rs = amp(1)*dexp(-10.d0*ys)-0.2d0*(amp(1)-xs)
      fintf = r**2-rs**2
      return
c
      end
