c
c ---------------------------------------------------------------
c
      subroutine fnpar(iloops)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /frontin/ xloop(maxfr),yloop(maxfr),rloop(maxfr),
     &       varloop(5,maxfr,maxfr),stdev(maxfr),ityloop(maxfr),
     &       ibdloop(maxfr),mwloop(maxfr),istloop(maxfr),
     &       newloop(maxfr),nloops,nfourier(maxfr),nrand(maxfr)
      common /intf0/ posn(2),dir(2),radius,iprobs
      common /perturb/ amp(30),wvnb(30),wvlen(30),phase(30),modes
      common /mathc/ pi
c
      go to (1,2,3,4,5,6,7) ityloop(iloops)
c
 1    continue
c     # planar front
      iprobs = 1
      posn(1) = xloop(iloops)
      posn(2) = yloop(iloops)
      theta = varloop(1,1,iloops)-90.d0
      dir(1) = dcos(theta*pi/180.d0)
      dir(2) = dsin(theta*pi/180.d0)
      return
c
 2    continue
c     # sinusodial front: periodic front (in y)
      iprobs = 2
      posn(1) = xloop(iloops)+1.d-3
      modes = nfourier(iloops)
c
      do mode=1,modes
         amp(mode)   = varloop(1,mode,iloops)
         wvnb(mode)  = varloop(2,mode,iloops)*2.d0*pi
         wvlen(mode) = varloop(3,mode,iloops)
         phase(mode) = varloop(4,mode,iloops)*pi
         enddo
      return
c
 3    continue
c     # sinusodial front: periodic front (in x)
      iprobs = 3
      posn(1) = xloop(iloops)
      posn(2) = yloop(iloops)+1.d-3
      modes = nfourier(iloops)
c
      do mode=1,modes
         amp(mode)   = varloop(1,mode,iloops)
         wvnb(mode)  = varloop(2,mode,iloops)*2.d0*pi
         wvlen(mode) = varloop(3,mode,iloops)
         phase(mode) = varloop(4,mode,iloops)*pi
         enddo
      return
c
 4    continue
c     # elliptical front
      iprobs = 4
      posn(1) = xloop(iloops)
      posn(2) = yloop(iloops)
      dir(1) = varloop(1,1,iloops)
      dir(2) = varloop(2,1,iloops)
      radius = varloop(3,1,iloops)
      return
c
 5    continue
c     # star-shaped front (close loop)
c     # point outward
      iprobs = 5
      posn(1) = xloop(iloops)
      posn(2) = yloop(iloops)
      radius  = rloop(iloops)-1.d-3
      modes = nfourier(1)
c
      do mode=1,modes
         amp(mode)   = varloop(1,mode,iloops)
         wvnb(mode)  = varloop(2,mode,iloops)*2.d0*pi
         wvlen(mode) = varloop(3,mode,iloops)
         phase(mode) = varloop(4,mode,iloops)*pi
         enddo
      return
c
 6    continue
c     # star-shaped front (close loop)
c     # point outward
      iprobs = 6
      posn(1) = xloop(iloops)
      posn(2) = yloop(iloops)
      radius  = rloop(iloops)-1.d-3
      modes = nfourier(1)
c
      do mode=1,modes
         amp(mode)   = varloop(1,mode,iloops)
         wvnb(mode)  = varloop(2,mode,iloops)*2.d0*pi
         wvlen(mode) = varloop(3,mode,iloops)
         phase(mode) = varloop(4,mode,iloops)*pi
         enddo
      return
c
 7    continue
c     # wound spiral
      iprobs = 7
      return
c
      end
