c
c --------------------------------------------------------------------
c
      subroutine godun0(q,irr,irrold,ul,ur,s,qjump,
     &                  mitot,mjtot,mmax,meqn,mwave,dt,xlow,ylow,
     &                  hx,hy,iorder,mbc,lstgrd,lstold,work)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /limiter/ mthslp(3),mthlim(3)
      common /param/ epsar,hsize,tol
      common /rpsolv/ iriem1,iriem2
      dimension q(mitot,mjtot,meqn)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
      dimension work(meqn),ul(mmax,meqn),ur(mmax,meqn)
      dimension s(mmax,mwave),qjump(mmax,meqn,mwave)
      dimension qja(20),qjb(20),pwave(20,2)
      data ixrp/1/, jyrp/0/
c      
c     # Godunov-type wave propagation method
c     # Update cell values based on solutions of Riemann problems
c     # from regular cell interfaces
c
      dt2 = dt
      if (iorder .eq. 2) dt2 = .5d0*dt
c
c     # x-sweep
c       =======
      do j=mbc,mjtot-mbc+1
c        # set Riemann data
         do m=1,meqn  
            do i=2,mitot   
               ul(i,m) = q(i-1,j,m)
               ur(i,m) = q(i,j,m)
               enddo
            enddo
c
c        # compute Riemann solutions
         call vrpjmp(ul,ur,s,qjump,work,2,mitot,mmax,meqn,
     &               mwave,ixrp,iriem1)
c
         yjm = ylow+dfloat(j-1)*hy 
         yjp = yjm+hy
c
c        # update solution
         do 90 i=mbc+1,mitot-mbc+1
            if ((iabs(irrold(i,j)) .ne. lstold) .or.
     &          (iabs(irrold(i-1,j)) .ne. lstold)) go to 90
c
            xi = xlow+dfloat(i-1)*hx 

c           # handle each waves in turn
            do 80 mw=1,mwave
c
c              # for numerical stability
               if (dabs(s(i,mw)) .lt. tol) go to 80
c
               ddx = s(i,mw)*dt2
               ddy = 0.d0
               if (ddx .gt. 0.d0) then
                   ix0 = i
                   do m=1,meqn
                      work(m) = -qjump(i,m,mw)
                      enddo
                   idir = 1
               else
                   ix0 = i-1
                   do m=1,meqn
                      work(m) = qjump(i,m,mw)
                      enddo
                   idir = -1
               endif
c
c              # make wave polygon
               call mkpowv(pwave,xi,yjm,xi,yjp,
     &                        ddx,ddy,idir,1)

               if (iabs(irr(ix0,j)) .eq. lstgrd) then
c                  # regular cell case
c
                   frac0 = dabs(ddx)/hx
                   do m=1,meqn
                      q(ix0,j,m) = q(ix0,j,m)+frac0*work(m)
                      enddo
               else
c                  # irregular cell case
c
                   call irrwv1(ix0,j,q,qirr,irr,work,pwave,
     &                     mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                     lstgrd)
               endif
c
               if (iorder .eq. 2) then
c                  # second order correction
                   is = i-dsign(1.d0,ddx)
c
                   tria = .5d0*dabs(ddx)*(hx-dabs(ddx))
c
c                  # compute slopes
                   do m=1,meqn
                      qja(m) = qjump(i,m,mw)
                      qjb(m) = qjump(is,m,mw)
                      enddo
c
                   call limter(work,qja,qjb,meqn,
     &                         mthslp(mw),mthlim(mw))
c
                   frac0 = tria/hx 
                   do m=1,meqn
                      q(i,j,m) = q(i,j,m)+frac0*work(m)
                      q(i-1,j,m) = q(i-1,j,m)-frac0*work(m)
                      enddo
               endif
 80            continue
 90         continue
         enddo
c
c     # set boundary states
      call hypbd(q,mitot,mjtot,meqn,mbc,work)
c
c     # y-sweep
c       =======
c
      do i=mbc,mitot-mbc+1
c        # set Riemann data
         do m=1,meqn
            do j=2,mjtot
               ul(j,m) = q(i,j-1,m)
               ur(j,m) = q(i,j,m)
               enddo
            enddo
c
c        # compute Riemann solutions
         call vrpjmp(ul,ur,s,qjump,work,2,mjtot,mmax,meqn,
     &               mwave,jyrp,iriem1)
c
         xim = xlow+dfloat(i-1)*hx 
         xip = xim+hx
c
c        # update solution
         do 190 j=mbc+1,mjtot-mbc+1
            if ((iabs(irrold(i,j)) .ne. lstold) .or.
     &          (iabs(irrold(i,j-1)) .ne. lstold)) go to 190
c
            yj = ylow+dfloat(j-1)*hy 
c
c           # handle each wave in turn
            do 180 mw=1,mwave
c
c              # for numerical stability
               if (dabs(s(j,mw)) .lt. tol) go to 180
c
               ddy = s(j,mw)*dt
               ddx = 0.d0
               if (ddy .gt. 0.d0) then
                   jy0 = j
                   do m=1,meqn
                      work(m) = -qjump(j,m,mw)
                      enddo
                   idir = -1
               else
                   jy0 = j-1
                   do m=1,meqn
                      work(m) = qjump(j,m,mw)
                      enddo
                   idir = 1
               endif
c
c              # make wave polygon
               call mkpowv(pwave,xim,yj,xip,yj,
     &                     ddx,ddy,idir,1)
c
               if (iabs(irr(i,jy0)) .eq. lstgrd) then
c                  # regular cell case
c
                   frac0 = dabs(ddy)/hy
                   do m=1,meqn
                      q(i,jy0,m) = q(i,jy0,m)+frac0*work(m)
                      enddo
               else
c                  # irregular cell case
c
                   call irrwv1(i,jy0,q,qirr,irr,work,pwave,
     &                         mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                         lstgrd)
               endif
c
               if (iorder .eq. 2) then
c                  # second order correction
                   js = j-dsign(1.d0,ddy)
c
                   tria = .5d0*dabs(ddy)*(hy-dabs(ddy))
c
c                  # compute slopes
                   do m=1,meqn
                      qja(m) = qjump(j,m,mw)
                      qjb(m) = qjump(js,m,mw)
                      enddo
c
                   call limter(work,qja,qjb,meqn,
     &                     mthslp(mw),mthlim(mw))
c
                   frac0 = tria/hy
                   do m=1,meqn
                      q(i,j,m) = q(i,j,m)+frac0*work(m)
                      q(i,j-1,m) = q(i,j-1,m)-frac0*work(m)
                      enddo
               endif
 180           continue
 190        continue
         enddo
c
      if (iorder .eq. 1) return
c
c     # set boundary states
      call hypbd(q,mitot,mjtot,meqn,mbc,work)
c
c     # x-sweep
c       =======
      do j=mbc,mjtot-mbc+1
c        # set Riemann data
         do m=1,meqn  
            do i=2,mitot   
               ul(i,m) = q(i-1,j,m)
               ur(i,m) = q(i,j,m)
               enddo
            enddo
c
c        # compute Riemann solutions
         call vrpjmp(ul,ur,s,qjump,work,2,mitot,mmax,meqn,
     &               mwave,ixrp,iriem1)
c
         yjm = ylow+dfloat(j-1)*hy 
         yjp = yjm+hy
c
c        # update solution
         do 290 i=mbc+1,mitot-mbc+1
            if ((iabs(irrold(i,j)) .ne. lstold) .or.
     &          (iabs(irrold(i-1,j)) .ne. lstold)) go to 290
c
            xi = xlow+dfloat(i-1)*hx 

c           # handle each waves in turn
            do 280 mw=1,mwave
c
c              # for numerical stability
               if (dabs(s(i,mw)) .lt. tol) go to 280
c
               ddx = s(i,mw)*dt2
               ddy = 0.d0
               if (ddx .gt. 0.d0) then
                   ix0 = i
                   do m=1,meqn
                      work(m) = -qjump(i,m,mw)
                      enddo
                   idir = 1
               else
                   ix0 = i-1
                   do m=1,meqn
                      work(m) = qjump(i,m,mw)
                      enddo
                   idir = -1
               endif
c
c              # make wave polygon
               call mkpowv(pwave,xi,yjm,xi,yjp,
     &                        ddx,ddy,idir,1)

               if (iabs(irr(ix0,j)) .eq. lstgrd) then
c                  # regular cell case
c
                   frac0 = dabs(ddx)/hx
                   do m=1,meqn
                      q(ix0,j,m) = q(ix0,j,m)+frac0*work(m)
                      enddo
               else
c                  # irregular cell case
c
                   call irrwv1(ix0,j,q,qirr,irr,work,pwave,
     &                     mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                     lstgrd)
               endif
c
               if (iorder .eq. 2) then
c                  # second order correction
                   is = i-dsign(1.d0,ddx)
c
                   tria = .5d0*dabs(ddx)*(hx-dabs(ddx))
c
c                  # compute slopes
                   do m=1,meqn
                      qja(m) = qjump(i,m,mw)
                      qjb(m) = qjump(is,m,mw)
                      enddo
c
                   call limter(work,qja,qjb,meqn,
     &                         mthslp(mw),mthlim(mw))
c
                   frac0 = tria/hx 
                   do m=1,meqn
                      q(i,j,m) = q(i,j,m)+frac0*work(m)
                      q(i-1,j,m) = q(i-1,j,m)-frac0*work(m)
                      enddo
               endif
 280           continue
 290        continue
         enddo
      return
c
 1001 format(6f12.6)
 1002 format(f12.6,2x,6f12.6)
      end
