c
c --------------------------------------------------------------------
c
      subroutine godunv(q,qold,irr,irrold,ul,ur,s,qjump,stan,qjtan,
     &                  mitot,mjtot,mmax,meqn,mwave,dt,xlow,ylow,
     &                  hx,hy,iorder,mbc,lstgrd,lstold,work)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /limiter/ mthslp(3),mthlim(3)
      common /param/ epsar,hsize,tol
      common /rpsolv/ iriem1,iriem2
      dimension q(mitot,mjtot,meqn),qold(mitot,mjtot,meqn)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
      dimension work(meqn),ul(mmax,meqn),ur(mmax,meqn)
      dimension s(mmax,mwave),qjump(mmax,meqn,mwave)
      dimension stan(mmax,mwave,mwave),qjtan(mmax,meqn,mwave,mwave)
      dimension ql(20),qr(20),stmp(3),qjtmp(20,3)
      dimension qja(20),qjb(20),pwave(20,2)
      data ixrp/1/, jyrp/0/
c      
c     # Godunov-type wave propagation method
c     # Update cell values based on solutions of Riemann problems
c     # from regular cell interfaces
c
      area0 = hx*hy
c
c     # x-sweep
c       =======
      do j=mbc,mjtot-mbc+1
c        # set Riemann data
         do m=1,meqn  
            do i=2,mitot   
               ul(i,m) = qold(i-1,j,m)
               ur(i,m) = qold(i,j,m)
               enddo
            enddo
c
c        # compute Riemann solutions
         call vrpjmp(ul,ur,s,qjump,work,2,mitot,mmax,meqn,
     &               mwave,ixrp,iriem1)
c
         do i=2,mitot
            do m=1,meqn
               ql(m) = ul(i,m)
               enddo
c
            do mw=1,mwave
c              # tangential splitting of waves
               do m=1,meqn
                  qr(m) = ql(m)+qjump(i,m,mw)
                  enddo
c
               call rpjmp(ql,qr,stmp,qjtmp,work,meqn,jyrp,iriem1,
     &                    nblow)
c
               if (nblow .eq. 1) then
                   write(6,*) 'x-sweep: i=', i
                   write(6,1001) (ul(i,m),m=1,meqn)
                   write(6,1001) (ur(i,m),m=1,meqn)
                   do mw0=1,mwave
                      write(6,1002) s(i,mw0),
     &                          (qjump(i,m,mw0),m=1,meqn)
                      enddo
                   stop
               endif
c
               do m=1,meqn
                  ql(m) = qr(m)
                  enddo
c
               do msubw=1,mwave 
                  stan(i,mw,msubw) = stmp(msubw)
                  do m=1,meqn
                     qjtan(i,m,mw,msubw) = qjtmp(m,msubw)
                     enddo
                  enddo
               enddo
            enddo
c
         yjm = ylow+dfloat(j-1)*hy 
         yjp = yjm+hy
c
c        # update solution
         do 90 i=mbc+1,mitot-mbc+1
            if ((iabs(irrold(i,j)) .ne. lstold) .or.
     &          (iabs(irrold(i-1,j)) .ne. lstold)) go to 90
c
            xi = xlow+dfloat(i-1)*hx 

c           # handle each waves in turn
            do 80 mw=1,mwave
c
c              # for numerical stability
               if (dabs(s(i,mw)) .lt. tol) go to 80
c
               ddx = s(i,mw)*dt
               if (ddx .gt. 0.d0) then
                   ix0 = i
                   do msubw=1,mwave
                      do m=1,meqn
                         qjtmp(m,msubw) = -qjtan(i,m,mw,msubw)
                         enddo
                      enddo
                   idir = 1
               else
                   ix0 = i-1
                   do msubw=1,mwave
                      do m=1,meqn
                         qjtmp(m,msubw) = qjtan(i,m,mw,msubw)
                         enddo
                      enddo
                   idir = -1
               endif
c
               do msubw=1,mwave
                  do m=1,meqn
                     work(m) = qjtmp(m,msubw)
                     enddo
c
                  ddy = stan(i,mw,msubw)*dt
                  tria = 0.5d0*dabs(ddx*ddy)
c
c                 # make wave polygon
                  call mkpowv(pwave,xi,yjm,xi,yjp,
     &                        ddx,ddy,idir,1)
c
                  if (iabs(irr(ix0,j)) .eq. lstgrd) then
c                     # regular cell case
c
                      frac0 = (hy*dabs(ddx)-tria)/area0
                      do m=1,meqn
                         q(ix0,j,m) = q(ix0,j,m)+frac0*work(m)
                         enddo
                  else
c                     # irregular cell case
c
                      call irrwv1(ix0,j,q,qirr,irr,work,pwave,
     &                     mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                     lstgrd)
                  endif
c
                  if (ddy .gt. 0.d0) then
                      jy0 = j+1
                  else
                      jy0 = j-1
                  endif
c
                  if ((jy0 .ge. 1) .and. (jy0 .le. mjtot)) then
                      if (iabs(irr(ix0,jy0)) .eq. lstgrd) then
c                         # regular cell case
c
                          frac0 = tria/area0
                          do m=1,meqn
                             q(ix0,jy0,m) = q(ix0,jy0,m)+
     &                                      frac0*work(m)
                             enddo
                      else
c                         # irregular cell case
c
                          call irrwv1(ix0,jy0,q,qirr,irr,work,
     &                         pwave,mitot,mjtot,meqn,xlow,ylow,
     &                         hx,hy,lstgrd)
                      endif
                  endif
                  enddo
c
                  if (iorder .eq. 2) then
c                     # second order correction
                      is = i-dsign(1.d0,ddx)
c
                      tria = .5d0*dabs(ddx)*(hx-dabs(ddx))
                      do msubw=1,mwave
                         ddy = stan(i,mw,msubw)*dt
c
c                        # compute slopes
                         do m=1,meqn
                            qja(m) = qjtan(i,m,mw,msubw)
                            qjb(m) = qjtan(is,m,mw,msubw)
                            enddo
c
                         call limter(work,qja,qjb,meqn,
     &                        mthslp(mw),mthlim(mw))
c
                         frac0 = (hy-dabs(ddy))*tria/area0 
                         frac1 = dabs(ddy)*tria/area0
c
                         if (ddy .gt. 0.d0) then
                             jy0 = j+1
                         else
                             jy0 = j-1
                         endif
c
                         do m=1,meqn
                            q(i,j,m) = q(i,j,m)+frac0*work(m)
                            q(i-1,j,m) = q(i-1,j,m)-frac0*work(m)
c
                            q(i,jy0,m) = q(i,jy0,m)+frac1*work(m)
                            q(i-1,jy0,m) = q(i-1,jy0,m)-frac1*work(m)
                            enddo
                         enddo
                  endif
 80            continue
 90         continue
         enddo
c
c     # y-sweep
c       =======
c
      do i=mbc,mitot-mbc+1
c        # set Riemann data
         do m=1,meqn
            do j=2,mjtot
               ul(j,m) = qold(i,j-1,m)
               ur(j,m) = qold(i,j,m)
               enddo
            enddo
c
c        # compute Riemann solutions
         call vrpjmp(ul,ur,s,qjump,work,2,mjtot,mmax,meqn,
     &               mwave,jyrp,iriem1)
c
         do j=2,mjtot   
            do m=1,meqn
               ql(m) = ul(j,m)
               enddo
c
            do mw=1,mwave
c              # tangential splitting of waves
               do m=1,meqn
                  qr(m) = ql(m)+qjump(j,m,mw)
                  enddo
c
               call rpjmp(ql,qr,stmp,qjtmp,work,meqn,ixrp,iriem1,
     &                    nblow)
c
               if (nblow .eq. 1) then
                   write(6,*) 'y-sweep: j=', j
                   write(6,1001) (ul(j,m),m=1,meqn)
                   write(6,1001) (ur(j,m),m=1,meqn)
                   do mw0=1,mwave
                      write(6,1002) s(j,mw0),
     &                       (qjump(j,m,mw0),m=1,meqn)
                      enddo
                   stop
               endif
c
               do m=1,meqn
                  ql(m) = qr(m)
                  enddo
c
               do msubw=1,mwave
                  stan(j,mw,msubw) = stmp(msubw)
                  do m=1,meqn
                     qjtan(j,m,mw,msubw) = qjtmp(m,msubw)
                     enddo
                  enddo
               enddo
            enddo
c
         xim = xlow+dfloat(i-1)*hx 
         xip = xim+hx
c
c        # update solution
         do 190 j=mbc+1,mjtot-mbc+1
            if ((iabs(irrold(i,j)) .ne. lstold) .or.
     &          (iabs(irrold(i,j-1)) .ne. lstold)) go to 190
c
            yj = ylow+dfloat(j-1)*hy 
c
c           # handle each wave in turn
            do 180 mw=1,mwave
c
c              # for numerical stability
               if (dabs(s(j,mw)) .lt. tol) go to 180
c
               ddy = s(j,mw)*dt
               if (ddy .gt. 0.d0) then
                   jy0 = j
                   do msubw=1,mwave
                      do m=1,meqn
                         qjtmp(m,msubw) = -qjtan(j,m,mw,msubw)
                         enddo
                      enddo
                   idir = -1
               else
                   jy0 = j-1
                   do msubw=1,mwave
                      do m=1,meqn
                         qjtmp(m,msubw) = qjtan(j,m,mw,msubw)
                         enddo
                      enddo
                   idir = 1
               endif
c
               do msubw=1,mwave
                  do m=1,meqn
                     work(m) = qjtmp(m,msubw)
                     enddo
c
                  ddx = stan(j,mw,msubw)*dt
                  tria = 0.5d0*dabs(ddx*ddy)
c
c                 # make wave polygon
                  call mkpowv(pwave,xim,yj,xip,yj,
     &                        ddx,ddy,idir,1)
c
                  if (iabs(irr(i,jy0)) .eq. lstgrd) then
c                     # regular cell case
c
                      frac0 = (hx*dabs(ddy)-tria)/area0
                      do m=1,meqn
                         q(i,jy0,m) = q(i,jy0,m)+frac0*work(m)
                         enddo
                  else
c                     # irregular cell case
c
                      call irrwv1(i,jy0,q,qirr,irr,work,pwave,
     &                     mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                     lstgrd)
                  endif
c
                  if (ddx .gt. 0.d0) then
                      ix0 = i+1
                  else
                      ix0 = i-1
                  endif
c
                  if ((ix0 .ge. 1) .and. (ix0 .le. mitot)) then
                      if (iabs(irr(ix0,jy0)) .eq. lstgrd) then
c                         # regular cell case
c
                          frac0 = tria/area0
                          do m=1,meqn
                             q(ix0,jy0,m) = q(ix0,jy0,m)+
     &                                      frac0*work(m)
                             enddo
                      else
c                         # irregular cell case
c
                          call irrwv1(ix0,jy0,q,qirr,irr,work,
     &                         pwave,mitot,mjtot,meqn,xlow,
     &                         ylow,hx,hy,stgrd)
                      endif
                  endif
                  enddo
c
               if (iorder .eq. 2) then
c                  # second order correction
                   js = j-dsign(1.d0,ddy)
c
                   tria = .5d0*dabs(ddy)*(hy-dabs(ddy))
                   do msubw=1,mwave
                      ddx = stan(j,mw,msubw)*dt
c
c                     # compute slopes
                      do m=1,meqn
                         qja(m) = qjtan(j,m,mw,msubw)
                         qjb(m) = qjtan(js,m,mw,msubw)
                         enddo
c
                      call limter(work,qja,qjb,meqn,
     &                     mthslp(mw),mthlim(mw))
c
                      frac0 = (hx-dabs(ddx))*tria/area0
                      frac1 = dabs(ddx)*tria/area0
c
                      if (ddx .gt. 0.d0) then
                          ix0 = i+1
                      else
                          ix0 = i-1
                      endif
c
                      do m=1,meqn
                         q(i,j,m) = q(i,j,m)+frac0*work(m)
                         q(i,j-1,m) = q(i,j-1,m)-frac0*work(m)
c
                         q(ix0,j,m) = q(ix0,j,m)+frac1*work(m)
                         q(ix0,j-1,m) = q(ix0,j-1,m)-frac1*work(m)
                         enddo
                      enddo
               endif
 180           continue
 190        continue
         enddo
c
 1001 format(6f12.6)
 1002 format(f12.6,2x,6f12.6)
      return
      end
