c
c -----------------------------------------------------------------
c
      subroutine ifront(vof,irr,irrold,mitot,mjtot,xlow,ylow,hx,hy,
     &                  lstgrd,lstfrt)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      dimension vof(mitot,mjtot)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
c
c     # advance tracked fronts to the next time step
c     # and insert them to the new grid
c
c     # ityfront = 1: tracked physical front
c     #          = 2: bdry front
c     #          = 4: arbitrary moving front
c     #          = 5: star surface
c     #          = 6: steady front
c
      area0 = hx*hy
c
c     # stationary fronts case
      kfront = lstfrt
      do 90 ifr=1,maxfr
         kfront = nxtfront(kfront)
         if (kfront .eq. 0) go to 100
	 if ((newfront(kfront) .eq. 1) .or.
     &       (ityfront(kfront) .eq. 1)) go to 90 
c
c        # set new front structure 
         newfr = maptr(2)
         lstbond(newfr) = lstptr(3)
         ityloop1(newfr) = ityloop1(kfront)
         loops(newfr) = loops(kfront)
         mwfront(newfr) = mwfront(kfront)
c
c        # copy stationary front and create new grid
         call stnfrt(kfront,newfr,irr,irrold,mitot,mjtot,
     &               xlow,ylow,hx,hy,lstgrd)
c
c        # set front type
	 call typfrt(newfr,ityfront(kfront))
 90      continue
 100  continue
c
c     # evloving fronts case
      kfront = lstfrt
      do 190 ifr=1,maxfr
         kfront = nxtfront(kfront)
         if (kfront .eq. 0) go to 200
         if ((newfront(kfront) .eq. 1) .or.
     &       (ityfront(kfront) .ne. 1)) go to 190
c
c        # set new front structure
         newfr = maptr(2)
         lstbond(newfr) = lstptr(3)
         ityloop1(newfr) = ityloop1(kfront)
         loops(newfr) = loops(kfront)
         mwfront(newfr) = mwfront(kfront)
c
c        # create grids
         kbond0 = lstbond(newfr)
         call vofint(vof,irr,mitot,mjtot,xlow,ylow,hx,hy,area0,
     &               lstgrd,kbond0)
c
c        # set front type
         call typfrt(newfr,ityfront(kfront))
 190     continue
 200  continue
c
c     # set edge-cell relation
      call edgcel(xlow,ylow,hx,hy,lstgrd)
c
      return
      end
