c
c ------------------------------------------------------------
c
      subroutine initq(q,mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                 work,time,iprob)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /fluid/ geos(maxfr),alp(maxfr),bet(maxfr),pnf(maxfr),
     &               zf(maxfr),psi(maxfr),mphase
      common /frontin/ xloop(maxfr),yloop(maxfr),rloop(maxfr),
     &       varloop(5,maxfr,maxfr),stdev(maxfr),ityloop(maxfr),
     &       ibdloop(maxfr),mwloop(maxfr),istloop(maxfr),
     &       newloop(maxfr),nloops,nfourier(maxfr),nrand(maxfr)
      common /init0/ rhol,ul,vl,pl,rhom,um,vm,pm,rhor,ur,vr,pr
      common /intar/ area,xc1,yc1
      common /intf0/ posn(2),dir(2),radius,iprobs
      common /perturb/ amp(maxfr),wvnb(maxfr),wvlen(maxfr),
     &                 phase(maxfr),modes
      common /phypar/ den0,sqrm,lnstate
      common /setqm/ qmult(2,20,maxfr)
      dimension q(mitot,mjtot,meqn),work(meqn)
      dimension ql(20),qm(20),qr(20)
c
c     # initialize state variables
c
      area0 = hx*hy
c
      go to (1,2) iprob
c
 1    continue
c     # Underwater explosion of a gas bubble
c     # radially-symmetric flow
c
c     # gas phase
      rhol = 1250.d0
      ul = 0.0d0
      vl = 0.0d0
      pl = 1.0d9
c
c     # liquid phase
      rhom = 1000.d0
      um = 0.0d0
      vm = 0.0d0
      pm = 1.0d5
c
c     # liquid phase
      rhor = 1.2d0
      ur = 0.0d0
      vr = 0.0d0
      pr = 1.0d5
c
      call prmtoc(ql,rhol,ul,vl,pl,geos(1),alp(1),
     &            bet(1),pnf(1),psi(1))
      call prmtoc(qm,rhom,um,vm,pm,geos(2),alp(2),
     &            bet(2),pnf(2),psi(2))
      call prmtoc(qr,rhor,ur,vr,pr,geos(3),alp(3),
     &            bet(3),pnf(3),psi(3))
c
c     # inner circle part
      call fnpar(1)
c
c     # initialize state values
      do i=1,mitot
         xi = xlow+dfloat(i-1)*hx
         do j=1,mjtot
            yj = ylow+dfloat(j-1)*hy
            call celave(xi,yj,hx,hy,area0,wl)
c
            do m=1,meqn
               q(i,j,m) = wl*ql(m)+(1.d0-wl)*qm(m)
               enddo
            enddo
         enddo
c
c     # outer interface   
      call fnpar(2)
c
c     # initialize state values
      do i=1,mitot
         xi = xlow+dfloat(i-1)*hx
         do j=1,mjtot
            yj = ylow+dfloat(j-1)*hy
            call celave(xi,yj,hx,hy,area0,wl)
c
            if (wl .ne. 1.d0) then
               do m=1,meqn
                   q(i,j,m) = wl*qm(m)+(1.d0-wl)*qr(m)
                   enddo
            endif
            enddo
         enddo
c
      do m=1,meqn
         qmult(1,m,1) = ql(m)
         qmult(2,m,1) = qm(m)
         qmult(1,m,2) = qm(m)
         qmult(2,m,2) = qr(m)
         enddo
      return
c
 2    continue
c     # bubble evolution
c
      call fnpar(1)
c
c     # liquid phase
      rhor = 1.d3
      ur = 1.d3
      vr = 1.d3
      pr = 1.d5
c
c     # gas phase
      rhol = 50.d0
      ul = 1.d3
      vl = 1.d3
      pl = 1.d5
c
      posn(1) = posn(1)+ul*time
      posn(2) = posn(2)+vl*time
      go to 777
c
 777  continue
      call prmtoc(ql,rhol,ul,vl,pl,geos(1),alp(1),
     &            bet(1),pnf(1),psi(1))
      call prmtoc(qr,rhor,ur,vr,pr,geos(2),alp(2),
     &            bet(2),pnf(2),psi(2))
c
 888  continue
      do i=1,mitot
         xi = xlow+dfloat(i-1)*hx
         do j=1,mjtot
            yj = ylow+dfloat(j-1)*hy
            call celave(xi,yj,hx,hy,area0,wl)
c
            do m=1,meqn
               q(i,j,m) = wl*ql(m)+(1.d0-wl)*qr(m)
               enddo
            enddo
         enddo
c
 990  continue
      do m=1,meqn
         qmult(1,m,1) = ql(m)
         qmult(2,m,1) = qr(m)
         enddo
      return
c
 1991 format('post-shock state: rho=',f24.10,', u=',f24.10,
     &       ', p=',f24.10,', mach=',f24.10)
 1992 format('contact (bo): rho=',f24.10,', u=',f24.10,
     &       ', v=',f24.10,', p=',f24.10, ', T=',f24.10)
 1994 format('contact (up): rho=',f24.10,', u=',f24.10,
     &       ', v=',f24.10,', p=',f24.10, ', T=',f24.10) 
      end
