c
c -----------------------------------------------------------------
c
      subroutine irrsd(q,qirr,irr,ql,qr,i,j,mitot,mjtot,meqn,
     &                 mwave,xlow,ylow,hx,hy,dt,x1,y1,x2,y2,
     &                 iface,work,lstgrd)   
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /param/ epsar,hsize,tol
      common /rpsolv/ iriem1,iriem2
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot)
      dimension qirr(6,20,maxbd),work(meqn)
      dimension s(3),qjump(20,3),stan(3),qjtan(20,3)
      dimension ql(20),qr(20),pwave(20,2) 
      data ixrp/1/, jyrp/0/
c
c     # update solutions using waves from irregular cell side
c
c      write(6,1001) (ql(m),m=1,meqn)
c      write(6,1001) (qr(m),m=1,meqn)
c
      go to (1,2) iface
c
 1    continue
c     # vertical face:
c     ---------------
c     # compute Riemann solutions
      call rpjmp(ql,qr,s,qjump,work,meqn,ixrp,iriem2,nblow)
c
c     # handle each wave in turn
      do 10 mw=1,mwave
         do m=1,meqn
            qr(m) = ql(m)+qjump(m,mw)
            enddo
c
c        # compute transverse Riemann solutions
         call rpjmp(ql,qr,stan,qjtan,work,meqn,jyrp,iriem2,nblow)
c
         do m=1,meqn
            ql(m) = qr(m)
            enddo
c
c        # for numerical stability
         if (dabs(s(mw)) .le. tol) go to 10
c
         ddx = s(mw)*dt
c
         if (s(mw) .gt. 0.d0) then
             ix0 = i
             idir = 1
         else
             ix0 = i-1
             idir = -1
         endif
c
         do msubw=1,mwave
            if (s(mw) .gt. 0.d0) then
                do m=1,meqn
                   work(m) = -qjtan(m,msubw)
                   enddo
            else
                do m=1,meqn
                   work(m) = qjtan(m,msubw)
                   enddo
            endif
c
            ddy = stan(msubw)*dt
c
c           # construct wave polygon (going clockwise)
            call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,1)
c
c           # propagate wave and update cell values
            call irrwv1(ix0,j,q,qirr,irr,work,pwave,mitot,
     &                  mjtot,meqn,xlow,ylow,hx,hy,lstgrd)
c
c           # numerical boundary condition
c            call nbcwv(ix0,j,q,qirr,irr,work,pwave,
c     &           mitot,mjtot,meqn,xlow,ylow,hx,hy,lstgrd,
c     &           iface,1)
c
            if (dabs(ddy) .ne. 0.d0) then
                jy0 = j+dsign(1.d0,ddy)
                call irrwv1(ix0,jy0,q,qirr,irr,work,pwave,mitot,
     &                  mjtot,meqn,xlow,ylow,hx,hy,lstgrd)
c
c               # numerical boundary condition
c                call nbcwv(ix0,jy0,q,qirr,irr,work,pwave,
c     &                     mitot,mjtot,meqn,lstgrd,iface,1)
            endif
            enddo
 10      continue
      return
c
 2    continue
c
c     # horizontal face:
c     ------------------
c     # solve Riemann problem using data ql and qr
      call rpjmp(ql,qr,s,qjump,work,meqn,jyrp,iriem2,nblow)
c
c     # handle each wave in turn
      do 20 mw=1,mwave
         do m=1,meqn
            qr(m) = ql(m)+qjump(m,mw)
            enddo
c
c        # solve Riemann problem using data ql and qr
         call rpjmp(ql,qr,stan,qjtan,work,meqn,ixrp,iriem2,nblow)
c
         do m=1,meqn
            ql(m) = qr(m)
            enddo
c
c        # for numerical stability
         if (dabs(s(mw)) .le. tol) go to 20
c
         ddy = s(mw)*dt
         if (s(mw) .gt. 0.d0) then
             jy0 = j
             idir = -1
         else
             jy0 = j-1
             idir = 1
         endif
c
         do msubw=1,mwave
            if (s(mw) .gt. 0.d0) then
                do m=1,meqn
                   work(m) = -qjtan(m,msubw)
                   enddo
            else
                do m=1,meqn
                   work(m) = qjtan(m,msubw)
                   enddo
            endif
c
            ddx = stan(msubw)*dt
c
c           # construct wave polygon (going clockwise)
            call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,1)
c
c           # propagate wave and update cell values
            call irrwv1(i,jy0,q,qirr,irr,work,pwave,mitot,
     &                  mjtot,meqn,xlow,ylow,hx,hy,lstgrd)
c
c           # numerical boundary condition
c            call nbcwv(i,jy0,q,qirr,irr,work,pwave,
c     &                 mitot,mjtot,meqn,lstgrd,iface,1)
c
            if (dabs(ddx) .ne. 0.d0) then
                ix0 = i+dsign(1.d0,ddx)
                call irrwv1(ix0,jy0,q,qirr,irr,work,pwave,mitot,
     &                      mjtot,meqn,xlow,ylow,hx,hy,lstgrd)
c
c               # numerical boundary condition
c                call nbcwv(ix0,jy0,q,qirr,irr,work,pwave,
c     &               mitot,mjtot,meqn,xlow,ylow,hx,hy,lstgrd,
c     &               iface,1)
            endif
            enddo
 20      continue
c
 1001 format('q=',10(e15.6,x))
      return
      end
