c
c --------------------------------------------------------------------
c
      subroutine irrwv1(ix0,jy0,q,qirr,irr,work,pwave,mitot,mjtot,
     &                  meqn,xlow,ylow,hx,hy,lstgrd)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot),work(meqn)
      dimension qirr(6,20,maxbd)
      dimension pwave(20,2),p1(20,2),dummy(20,2)
c
c     # first order pwave propagation on the irregular cells
c     # given polygon of pwave and the index of the cells which may
c     # be affected by this pwave, 
c     # then find the intersection area and use it to update
c     # the cell-averaged values
c
      if((ix0 .lt. 1) .or. (ix0 .gt. mitot) .or. 
     &   (jy0 .lt. 1) .or. (jy0 .gt. mjtot)) return
c
      iptr = irr(ix0,jy0)
      if (iptr .eq. -lstgrd) return
c
c     # ignore weak waves
      wnorm = 0.d0
      do m=1,meqn
         wnorm = dmax1(wnorm,dabs(work(m)))
         enddo
      if (wnorm .lt. 1.d-12) return
c
c     # find the intersection of pwave with this polygon (ix0,jy0)
      if (iptr .eq. lstgrd) then
c         # regular cell case
          xi = xlow+dfloat(ix0-1)*hx
          yj = ylow+dfloat(jy0-1)*hy
          p1(1,1) = xi
          p1(1,2) = yj
          p1(2,1) = xi
          p1(2,2) = yj+hy
          p1(3,1) = xi+hx
          p1(3,2) = yj+hy
          p1(4,1) = xi+hx
          p1(4,2) = yj
          p1(5,1) = xi
          p1(5,2) = yj
          p1(6,1) = -99.d0
          p1(6,2) = -99.d0 
c
          call poin2d(pwave,p1,dummy,area)
c
          frac = area/ar(1,lstgrd)
          do m=1,meqn
             q(ix0,jy0,m) = q(ix0,jy0,m)+frac*work(m)
             enddo
      else
c         # irregular cell case
          do icell=1,ncells(iptr)
             do jj=1,2
                do ii=1,10
                   p1(ii,jj) = poly(icell,ii,jj,iptr)
                   enddo
                enddo
c
             call poin2d(pwave,p1,dummy,area)
c
             frac = area/ar(icell,iptr)
             do m=1,meqn
                qirr(icell,m,iptr) = qirr(icell,m,iptr)+frac*work(m)
                enddo
             enddo
      endif
c
 1001 format('entering irrwv1 routine: ix=',i4,', jy=',i4,
     &       ', iptr=',i4,', type=',i3)
 1002 format('ar=',e12.4,', arsub=',e12.4,', qjump=',f12.6)
 1003 format('icell=',i3,', q=',e12.6)
      return
c
      end
