c
c     # Note this is not a bug-free code
c --------------------------------------------------------------
c
      program main
      implicit double precision (a-h,o-z)
      parameter(mxloc=4999999,maxfr=100,maxbd=5560)
      common /bcs/ ibc(4)
      common /calloc/ alloc(mxloc)
      common /domain/ corn(2,2)
      common /fluid/ geos(maxfr),alp(maxfr),bet(maxfr),pnf(maxfr),
     &               zf(maxfr),psi(maxfr),mphase
      common /frontin/ xloop(maxfr),yloop(maxfr),rloop(maxfr),
     &       varloop(5,maxfr,maxfr),stdev(maxfr),ityloop(maxfr),
     &       ibdloop(maxfr),mwloop(maxfr),istloop(maxfr),
     &       newloop(maxfr),nloops,nfourier(maxfr),nrand(maxfr)
      common /limiter/ mthslp(3),mthlim(3)
      common /phypar/ den0,sqrm,lnstate
      common /rpsolv/ iriem1,iriem2
      common /sterms/ gravc(2),nsource,isource(10),igeom
      common /vof0/ ivof,iflow,mw0
      dimension work(20)
      logical vtime,lerror,ldiag,lstrt
      character*8 pltfile,infile,outfile
c
c     # main program for 2D front-tracking algorithm
c     # Volume-tracking version
c     # Governing equations: Euler equations of gas dynamics
c     # Equation of state: van der Waals EOS
c
c     # Reference: Shyue, J. Korean Astro. Soc. 34, S237-241, 2001
c
      infile  = 'tape5'
      outfile = 'tape6'
      pltfile = 'plot.3'
      open(3,file=pltfile,status='unknown',form='formatted')
      open(5,file=infile,status='old',form='formatted')
      open(6,file=outfile,status='unknown',form='formatted')
      open(97,file='front.d',status='unknown',form='formatted')
c
c     # input data
      read(5,*) lstrt                   ! restart
      read(5,*) meqn         		! meqn
      read(5,*) mwave       		! mwave
      read(5,*) iprob        		! iprob  
      read(5,*) corn(1,1),corn(1,2),
     &          corn(2,1),corn(2,2) 	! computational domain
      read(5,*) ibc(1),ibc(2),
     &          ibc(3),ibc(4)		! boundary condition
      read(5,*) hx,hy                   ! mesh spacing
      read(5,*) vtime,cfl,dt0           ! time step option
      read(5,*) nstop,tstop             ! stopping option
      read(5,*) io2d,io1d               ! printting option
      read(5,*) lerror,itrue            ! error estimation
      read(5,*) ldiag 
c
c     # input tracked interface info
      read(5,*) nloops
      do i=1,nloops
         read(5,*) istloop(i),newloop(i),ibdloop(i),
     &             ityloop(i),mwloop(i)
         read(5,*) xloop(i),yloop(i),rloop(i)
         read(5,*) nfourier(i),nrand(i),stdev(i)
         read(5,*) ((varloop(ivar,j,i),ivar=1,5),j=1,nfourier(i))
         enddo
c
      read(5,*) imeth,iorder
      read(5,*) itrack,irrmd
      read(5,*) (mthslp(mw),mw=1,mwave) ! method of slopes
      read(5,*) (mthlim(mw),mw=1,mwave) ! method of limiters
      read(5,*) iriem1,iriem2
      read(5,*) ivof,iflow,mw0
      read(5,*) mphase
      read(5,*) nlayer,(geos(i),i=1,nlayer)
      read(5,*)        (alp(i),i=1,nlayer)
      read(5,*)        (bet(i),i=1,nlayer)
      read(5,*)        (pnf(i),i=1,nlayer)
      read(5,*)        (psi(i),i=1,nlayer)
      read(5,*) den0,sqrm,lnstate
      read(5,*) itmsp			! source terms treatment
      read(5,*) nsource,(isource(i),i=1,nsource)
      read(5,*) igeom                   ! igeom
      read(5,*) gravc(1),gravc(2)       ! gravitational constants
c
c     # set miscellaneous parameters
c     ==============================
      call setpar(mitot,mjtot,mbc,iorder,hx,hy)
c
      time = 0.d0
      nbeg = 0
      dt = dt0
c
      xlow = corn(1,1)-dfloat(mbc)*hx
      ylow = corn(2,1)-dfloat(mbc)*hy
c
      if (lstrt) then
c         # restart program from check file
          rewind 9
          call restrt(nbeg,time,locq1,locq2,locv1,locv2,
     &                locirr,lociro,lstgrd,lstfrt)
          go to 10
      endif
c
c     # set initial condition
c     =======================
c
c     # data structure: preliminary setup
      call setpre(lstgrd,lstfrt)
c
c     # main memory location
c     # for solution states
      locq1 = maloc(mitot*mjtot*meqn)
      locq2 = maloc(mitot*mjtot*meqn)
c
c     # for volume of fluid
      locv1 = maloc(mitot*mjtot)
      locv2 = maloc(mitot*mjtot)
c
c     # for irregular cell 
      locirr = maloc(mitot*mjtot)
      lociro = maloc(mitot*mjtot)
c
c     # for front structure & also the grid
      call setgrd(alloc(locv1),alloc(locirr),mitot,mjtot,
     &            xlow,ylow,hx,hy,lstgrd,lstfrt,iprob,itrack)
c
      call newvof(alloc(locv1),alloc(locirr),mitot,mjtot,lstgrd)
c
c     # for solution states
      call initq(alloc(locq1),mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &           work,time,iprob)
      call setqir(alloc(locirr),mitot,mjtot,meqn,lstgrd,
     &            lstfrt,time,work,iprob)
c
c     # data diagnosis
      if (ldiag) then
          iunit = 36
          call diagns(alloc(locq1),alloc(locirr),mitot,mjtot,meqn,
     &                work,time,hx,hy,mbc,lstgrd,iunit)
      endif
c
c     # tracked front output
      call outbnd(lstfrt,11)
      call outbnd(lstfrt,97)
c
 10   continue
c     # main integration loop
c     =======================
c
c     # temporary storage
      mmax = max(mitot,mjtot)
      locql = maloc(mmax*meqn)
      locqr = maloc(mmax*meqn)
      locsn = maloc(mmax*mwave)
      locqj = maloc(mmax*meqn*mwave)
      locst = maloc(mmax*mwave*mwave)
      loqjt = maloc(mmax*meqn*mwave*mwave)
      locwk = maloc(maxbd*meqn*6)  
c
      do 900 nstep=nbeg+1,nstop
c        # set boundary states
         call hypbd(alloc(locq1),mitot,mjtot,meqn,mbc,work)
c
c        # compute variable time
         if (vtime) call vartme(alloc(locq1),alloc(locirr),
     &                          mitot,mjtot,meqn,hx,hy,time,
     &                          nstep,dt,work,cfl,lstgrd)
c
         if (time+dt .gt. tstop) dt = tstop-time
c
         if ((iorder .eq. 2) .and. (itmsp .eq. 1)) then
c            # handle source terms
             call source(alloc(locq1),alloc(locirr),
     &            mitot,mjtot,meqn,dt,lstgrd,iorder,work)
c
c            # set boundary states
             call hypbd(alloc(locq1),mitot,mjtot,meqn,mbc,work)
         endif
c
c        # solve Riemann problems at the tracked interfaces
         call rfront(alloc(locirr),mitot,mjtot,meqn,mwave,
     &               lstfrt,work)

c        # make new grid preliminary
         call mkgrid(alloc(locq1),alloc(locq2),alloc(locv1),
     &               alloc(locv2),alloc(locirr),alloc(lociro),
     &               mitot,mjtot,meqn,lstgrd,lstold,work)
c
c        # update vof
         call vofnst(alloc(locv1),alloc(locv2),alloc(locq2),
     &               alloc(lociro),alloc(locql),alloc(locqr),
     &               alloc(locsn),mitot,mjtot,mmax,
     &               meqn,mwave,xlow,ylow,hx,hy,dt,mbc,lstold,
     &               lstfrt,work)

c        # make moving fronts
         call ifront(alloc(locv1),alloc(locirr),alloc(lociro),
     &               mitot,mjtot,xlow,ylow,hx,hy,lstgrd,lstfrt)
c
c        # initialize states on new irregular cell
         call newqir(alloc(locq2),alloc(locirr),alloc(lociro),
     &               mitot,mjtot,meqn,lstgrd,lstold)
         call newvof(alloc(locv1),alloc(locirr),mitot,mjtot,lstgrd)
c
c        # solution update
         if (imeth .eq. 1) then
c            # dimensional splitting approach
c
             call godun0(alloc(locq1),alloc(locirr),
     &               alloc(lociro),alloc(locql),
     &               alloc(locqr),alloc(locsn),alloc(locqj),
     &               mitot,mjtot,mmax,
     &               meqn,mwave,dt,xlow,ylow,hx,hy,
     &               iorder,mbc,lstgrd,lstold,work)
         else
c            # unsplit approach
c
             call godunv(alloc(locq1),alloc(locq2),alloc(locirr),
     &               alloc(lociro),alloc(locql),
     &               alloc(locqr),alloc(locsn),alloc(locqj),
     &               alloc(locst),alloc(loqjt),mitot,mjtot,mmax,
     &               meqn,mwave,dt,xlow,ylow,hx,hy,
     &               iorder,mbc,lstgrd,lstold,work)
         endif
c
c        # irregular cells case
         call pfront(alloc(locq1),alloc(locq2),alloc(locirr),
     &               alloc(lociro),mitot,mjtot,meqn,mwave,
     &               xlow,ylow,hx,hy,dt,mbc,lstgrd,lstold,lstfrt,
     &               work)
c
c        # delete the old front
         call dfront(lstold,lstgrd,lstfrt)

c        # handle source terms
         call source(alloc(locq1),alloc(locirr),mitot,mjtot,meqn,
     &               dt,lstgrd,iorder,work)
c
c        # correct irregular cell values
         if (irrmd .eq. 1)
     &       call extirr(alloc(locq1),alloc(locv1),alloc(locirr),
     &                   alloc(locwk),mitot,mjtot,meqn,lstgrd,work) 
c
c        # update time
         time = time+dt
c
         write(6,1002) nstep,time,dt
c
c        # check for the termination of the program
         if ((time .ge. tstop) .or. (nstep .eq. nstop))
     &       go to 999
 900     continue
c
 999  continue
c     # output solutions
c
c     # compute "true" solution
      call qtrue(alloc(locq2),mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &           work,time,iprob,itrue)
c
      iunit = 3
      call outvar(alloc(locq1),alloc(locv1),alloc(locirr),
     &            mitot,mjtot,meqn,lstgrd,work,mbc,io2d,iunit)
c
      iunit = 21
      call outva1(alloc(locq1),alloc(locirr),
     &            mitot,mjtot,meqn,xlow,ylow,hx,hy,lstgrd,
     &            work,mbc,io1d,iunit)
c
      if (itrue .ne. 0) then
          iunit = 22
          call outva1(alloc(locq1),alloc(locirr),mitot,mjtot,meqn,
     &                xlow,ylow,hx,hy,lstgrd,work,mbc,io1d,iunit)
      endif
c
      call outbnd(lstfrt,12)
      call outbnd(lstfrt,97)
c
      call free(locql,mmax*meqn)
      call free(locqr,mmax*meqn)
      call free(locsn,mmax*mwave)
      call free(locqj,mmax*meqn*mwave)
      call free(locst,mmax*mwave*mwave)
      call free(loqjt,mmax*meqn*mwave*mwave)
      call free(locwk,maxbd*meqn*6) 
c
c     # check file for program restrts
      call check(nstep,time,locq1,locq2,locv1,locv2,
     &           locirr,lociro,lstgrd,lstfrt)
c
      write(51,1003) mitot,mjtot,mbc,corn(1,1),corn(2,1),
     &               hx,hy,meqn
c
      write(6,1004)
c
 1001 format(4f18.12)
 1002 format('nstep=',i5,', time=',f12.6,', dt=',f12.6)
 1003 format(3i5,4f12.6,i5)
 1004 format(/,' ------  end of integration --------  ')
 1005 format(2f12.8)
 1006 format('i=',i3,', j=',i3,5f13.8)
c
      stop 
      end
