c
c ------------------------------------------------------------------
c
      subroutine mkirrc(irr,ix,jy,x0,y0,x1,y1,mitot,mjtot,xlow,ylow,
     &                  hx,hy,lstgrd,newbd0,newbd,ismall)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension irr(mitot,mjtot),p1(20,2),p2(20,2),p3(20,2)
      data idebug/0/
c
c     # given bond location (x0,y0),(x1,y1)
c     # split cell (ix,jy) into subcells
c
      iptr = irr(ix,jy)
      if (iptr .eq. lstgrd) then
c         # get index for new irregular cell
          iptr = maptr(1)
      elseif (ityirr(iptr) .eq. 2) then
c         # avoid splitting outside boundary cells
c         # irregular cell case
          do ibd=1,nbonds(iptr)
             kbond = nbondc(ibd,iptr)
             if (itybond(kbond) .eq. 2) go to 19
             enddo
          write(6,*) 'ERROR in mkirrc'
          stop
c
 19       continue
          x2 = points(1,1,kbond)
          y2 = points(1,2,kbond)
          x3 = points(2,1,kbond)
          y3 = points(2,2,kbond)
          sign0 = area2(x2,y2,x3,y3,x0,y0)
          sign1 = area2(x2,y2,x3,y3,x1,y1)
          if ((sign0 .le. 0.d0) .and. (sign1 .le. 0.d0)) then
              write(6,*) 'in mkirrc: boundary cell (ix,jy) =',ix,jy
              write(6,*) 'sign0=',sign0,', sign1=',sign1
              return
          endif
      endif
c
c     # make bond
      call mkbond(newbd,ix,jy,x0,y0,x1,y1,newbd0,ismall)
c
c     # create subcell polygon
      icell = ncells(iptr)
      if (icell .eq. 1) then
	  jcell = 1
          xi = xlow+dfloat(ix-1)*hx
          yj = ylow+dfloat(jy-1)*hy
          p1(1,1) = xi
          p1(1,2) = yj
          p1(2,1) = xi
          p1(2,2) = yj+hy
          p1(3,1) = xi+hx
          p1(3,2) = yj+hy
          p1(4,1) = xi+hx
          p1(4,2) = yj
          p1(5,1) = xi
          p1(5,2) = yj
          p1(6,1) = -99.d0
          p1(6,2) = -99.d0
      else
c         # locate the splitted subcell index
          jcell = insbc(x0,y0,x1,y1,iptr,newbd)
c
c         # split this subcell into two parts
          do jj=1,2
             do ii=1,10
                p1(ii,jj) = poly(jcell,ii,jj,iptr)
                enddo
             enddo
      endif
c
c     # post-shock subcell
      call spoly(p1,p2,x0,y0,x1,y1,ismall,ar(1,lstgrd))
      if (ismall .eq. 1) then
	  write(6,1004) iptr,ix,jy,newbd,ityirr(iptr)
	  write(6,1001) x0,y0,x1,y1
	  write(6,*) '------------'
c
          if (icell .eq. 1) call putptr(iptr,1)
	  return
      endif
c
c     # pre-shock subcell
      call spoly(p1,p3,x1,y1,x0,y0,ismall,ar(1,lstgrd))
      if (ismall .eq. 1) then
	  write(6,1001) x0,y0,x1,y1
	  write(6,1004) iptr,ix,jy,newbd,ityirr(iptr)
	  return
      endif
c
      call mkpoly(p2,jcell,iptr)
      call mkpoly(p3,icell+1,iptr)
c
      irr(ix,jy) = iptr
      ixc(iptr) = ix
      jyc(iptr) = jy
      ncells(iptr) = ncells(iptr)+1
      nbonds(iptr) = nbonds(iptr)+1
      nbondc(nbonds(iptr),iptr) = newbd
c
c     # set bond-cell correspondence
      call setbdc(iptr)
c
      if (idebug .eq. 1) then
          write(6,*) 'entering mkirrc:'
          write(6,1004) iptr,ix,jy,newbd,ityirr(iptr)
          do 210 i0=1,2
             is = irrcell(i0,newbd)
             write(6,1003) is,ar(is,iptr)
             do ii=1,10
                if(poly(is,ii,1,iptr) .eq. -99.d0) go to 210
                write(6,1001) (poly(is,ii,jj,iptr),jj=1,2)
                enddo
 210         continue
          write(6,*) '---------------------------------------------'
      endif
c
 1001 format(4f12.6)
 1003 format(i3,x,f14.10)
 1004 format('iptr=',i4,', ix=',i3,', jy=',i3,', kbond=',i4,
     &       ', ityirr=',i3)
c
      return
      end
