c
c ------------------------------------------------------------------
c
      subroutine nbcwv(ix0,jy0,q,qirr,irr,work,pwave,mitot,mjtot,
     &                 meqn,lstgrd,iedg,itype)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /bcs/ ibc(4)
      common /domain/ corn(2,2)
      common /index/ ix1,ixn,jy1,jyn
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot)
      dimension work(meqn)
      dimension qirr(6,8,maxbd)
      dimension pwave(20,2),hs(20,2),rnpoly(20,2)
c
c     # numerical boundary condition for solid walls or
c     # periodic boundaries
c
      lbdry = 0
      if (ix0 .eq. ix1) then
c         # left boundary
          iebc = 1
          if (((itype .eq. 1) .and. (iedg .ne. 1)) .or.
     &        (itype .eq. 2)) lbdry = 1
      elseif (jy0 .eq. jyn) then
c         # top boundary
          iebc = 2
          if (((itype .eq. 1) .and. (iedg .ne. 2)) .or.
     &        (itype .eq. 2)) lbdry = 1
      elseif (ix0 .eq. ixn) then
c         # right boundary
          iebc = 3
          if (((itype .eq. 1) .and. (iedg .ne. 1)) .or.
     &        (itype .eq. 2)) lbdry = 1
      elseif (jy0 .eq. jy1) then
c         # bottom boundary
          iebc = 4
          if (((itype .eq. 1) .and. (iedg .ne. 2)) .or.
     &        (itype .eq. 2)) lbdry = 1
      endif
c
c     # periodic boundary
      if ((lbdry .eq. 1) .and. (ibc(iebc) .eq. 3)) then
c
c         # reflected periodic boundary waves
c         # (1) calculate the reflected polygon
c         # (2) propagate the reflected wave
c
c         # step 1: calculate the reflected polygon
          xpd = 0.d0
          ypd = 0.d0
          if (iebc .eq. 1) then
              hs(1,1) = corn(1,1)
              hs(1,2) = corn(2,2)
              hs(2,1) = corn(1,1)
              hs(2,2) = corn(2,1)
              xpd = corn(1,2)
          elseif (iebc .eq. 2) then
              hs(1,1) = corn(1,2)
              hs(1,2) = corn(2,2)
              hs(2,1) = corn(1,1)
              hs(2,2) = corn(2,2)
              ypd = -corn(2,2)
          elseif (iebc .eq. 3) then
              hs(1,1) = corn(1,2)
              hs(1,2) = corn(2,1)
              hs(2,1) = corn(1,2)
              hs(2,2) = corn(2,2)
              xpd = -corn(1,2)
          else
              hs(1,1) = corn(1,1)
              hs(1,2) = corn(2,1)
              hs(2,1) = corn(1,2)
              hs(2,2) = corn(2,1)
              ypd = corn(2,2)
          endif
          hs(3,1) = -99.d0
          hs(3,2) = -99.d0
c
          call poin2d(hs,pwave,rnpoly,area)
          if (area .eq. 0.d0) return
c
          do i=1,20
             if (rnpoly(i,1) .eq. -99.d0) go to 19
             hs(i,1) = rnpoly(i,1)+xpd
             hs(i,2) = rnpoly(i,2)+ypd
             enddo
 19       continue
          hs(i,1) = -99.d0
          hs(i,2) = -99.d0
c
c         # step 2: propagate the reflected wave
          if ((iebc .eq. 1) .or. (iebc .eq. 3)) then
              ix = mitot-ix0+1
              jy = jy0
          else
              ix = ix0
              jy = mjtot-jy0+1
          endif
c
          call irrwv1(ix,jy,q,qirr,irr,work,hs,mitot,mjtot,
     &                meqn,lstgrd)
      endif
c
      return
      end
