c
c -------------------------------------------------------------
c
      subroutine outva1(q,irr,mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                  lstgrd,work,mbc,io1d,iunit)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /intf0/ posn(2),dir(2),radius,iprobs 
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot)
      dimension work(meqn)
c
c     # output a one-dimensional array of data
c
      go to (1,2,3,4) io1d 
c
 1    continue
c     # output data in the x-cross section
      j = (mjtot+1)/2
      do i=mbc+1,mitot-mbc
         if (irr(i,j) .eq. -lstgrd) then
             write(iunit,*) '0. NaN NaN NaN NaN NaN NaN NaN NaN'
         elseif (iabs(irr(i,j)) .ne. lstgrd) then
             iptr = irr(i,j)
             do icell=1,ncells(iptr)
                x = xcen(icell,iptr)
	        do m=1,meqn
		   work(m) = qirr(icell,m,iptr)
                   enddo
c
                call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,
     &                      gam0,alp0,bet0,pn0,psi0)
c
                tau = 1.d0/rho
                temp = (tau-bet0)*(p+pn0+alp0/tau**2)
c
                write(iunit,1001) x,rho,u,v,p,temp,gam0,alp0,psi0
                enddo
         else
             x = xlow+(dfloat(i-1)+0.5d0)*hx
	     do m=1,meqn
	        work(m) = q(i,j,m)
                enddo
c
             call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,
     &                   gam0,alp0,bet0,pn0,psi0)
c
             tau = 1.d0/rho
             temp = (tau-bet0)*(p+pn0+alp0/tau**2)
c
             write(iunit,1001) x,rho,u,v,p,temp,gam0,alp0,psi0 
         endif
         enddo
      go to 999
c
 2    continue
c     # output data in the y-cross section
      i = (mitot+1)/2
      do j=mbc+1,mjtot-mbc
         if (irr(i,j) .eq. -lstgrd) then
             write(iunit,*) '0. NaN NaN NaN NaN NaN NaN NaN NaN'
         elseif (iabs(irr(i,j)) .ne. lstgrd) then
             iptr = irr(i,j)
             do icell=1,ncells(iptr)
                y = ycen(icell,iptr)
                do m=1,meqn
                   work(m) = qirr(icell,m,iptr)
                   enddo
c
                call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,
     &                      gam0,alp0,bet0,pn0,psi0)
c
                tau = 1.d0/rho
                temp = (tau-bet0)*(p+pn0+alp0/tau**2)
c
                write(iunit,1001) y,rho,u,v,p,temp,gam0,alp0,psi0 
                enddo
         else
             y = ylow+(dfloat(j-1)+0.5d0)*hy  
             do m=1,meqn
                work(m) = q(i,j,m)
                enddo
c
             call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,gam0,
     &                   alp0,bet0,pn0,psi0)
c
             tau = 1.d0/rho
             temp = (tau-bet0)*(p+pn0+alp0/tau**2)
             write(iunit,1001) y,rho,u,v,p,temp,gam0,alp0,psi0  
         endif
         enddo
      go to 999
c
 3    continue
c     # output data in the diagonal section
      do j=mbc+1,mjtot-mbc
         do i=mbc+1,mitot-mbc
            if (i .eq. j) then
                if (irr(i,j) .eq. -lstgrd) then
                    write(iunit,*) '0. NaN NaN NaN NaN NaN NaN NaN NaN'
                elseif (iabs(irr(i,j)) .ne. lstgrd) then
                    iptr = irr(i,j)
                    do icell=1,ncells(iptr)
                       x = xcen(icell,iptr)
                       y = ycen(icell,iptr)
                       do m=1,meqn
                          work(m) = qirr(icell,m,iptr)
                          enddo
c
                       call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                             gru0,gam0,alp0,bet0,pn0,psi0)
c
                       ds = dsqrt(x*x+y*y)
                       tau = 1.d0/rho
                       temp = (tau-bet0)*(p+pn0+alp0/tau**2)
                       write(iunit,1001) ds,rho,u,v,p,temp,gam0,
     &                                   alp0,psi0
                    enddo
                else
                    x = xlow+(dfloat(i-1)+0.5d0)*hx
                    y = ylow+(dfloat(j-1)+0.5d0)*hy
                    do m=1,meqn
                       work(m) = q(i,j,m)
                       enddo
c
                    call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                          gru0,gam0,alp0,bet0,pn0,psi0)
c
                    ds = dsqrt(x*x+y*y)
                    tau = 1.d0/rho
                    temp = (tau-bet0)*(p+pn0+alp0/tau**2)
                    write(iunit,1001) ds,rho,u,v,p,temp,gam0,alp0,psi0
                endif
            endif
            enddo
         enddo
      go to 999
c
 4    continue
c     # scatter plot in radial direction
c
      call fnpar(1)
      x0 = posn(1)
      y0 = posn(2)
c
      do j=mbc+1,mjtot-mbc
         y = ylow+(dfloat(j-1)+0.5d0)*hy
         do i=mbc+1,mitot-mbc
            x = xlow+(dfloat(i-1)+0.5d0)*hx
            if (irr(i,j) .eq. -lstgrd) then
                write(iunit,*) '0. NaN NaN NaN NaN NaN NaN NaN NaN'
            elseif (iabs(irr(i,j)) .ne. lstgrd) then
                    iptr = irr(i,j)
                    do icell=1,ncells(iptr)
                       x = xcen(icell,iptr)
                       y = ycen(icell,iptr)
                       do m=1,meqn
                          work(m) = qirr(icell,m,iptr)
                          enddo
c
                       call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                             gru0,gam0,alp0,bet0,pn0,psi0)
c
                       rr = dsqrt((x-x0)**2+(y-y0)**2)
c
                       tau = 1.d0/rho
                       temp = (tau-bet0)*(p+pn0+alp0/tau**2)
                       rhok1 = .5d0*rho*(u*u+v*v)
                       u0 = dsqrt(2.d0*rhok1/rho)
c
                       write(iunit,1001) rr,rho,u0,p,temp,gam0,
     &                            alp0,bet0,psi0 
                    enddo 
           else
                do m=1,meqn
                   work(m) = q(i,j,m)
                   enddo
c
                call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,
     &                      gam0,alp0,bet0,pn0,psi0)
                rr = dsqrt((x-x0)**2+(y-y0)**2)
c
                tau = 1.d0/rho
                temp = (tau-bet0)*(p+pn0+alp0/tau**2)
                rhok1 = .5d0*rho*(u*u+v*v)
                u0 = dsqrt(2.d0*rhok1/rho)
                write(iunit,1001) rr,rho,u0,p,temp,gam0,
     &                            alp0,bet0,psi0
            endif
            enddo
         enddo
      go to 999
c
 999  continue
      write(iunit,*) '0. NaN NaN NaN NaN NaN NaN NaN NaN'
      return
c
 1001 format(9f24.10) 
      end
