c
c -----------------------------------------------------------------
c
      subroutine pfront(q,qold,irr,irrold,mitot,mjtot,meqn,mwave,
     &                  xlow,ylow,hx,hy,dt,mbc,lstgrd,lstold,lstfrt,
     &                  work)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /frps/ sfront(maxbd,3),stfront(maxbd,3,3),
     &              qjtfront(maxbd,20,3,3)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkedge/ iedge(4,maxbd),iecell(4,6,maxbd),
     &                edgp(2,2,4,6,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /param/ epsar,hsize,tol
      dimension q(mitot,mjtot,meqn),qold(mitot,mjtot,meqn)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
      dimension work(meqn)
      dimension pwave(20,2),ql(20),qr(20)
      data idebug/0/  
c
c     # update irregular cell values to the next time step
c
      if (idebug .ne. 0) then
          write(6,*) 'Entering pfront routine'
          write(6,*) '------------------------'
          iptr = lstgrd
          do ik=1,maxbd
             iptr = nxtirr(iptr)
             if (iptr .eq. 0) go to 919
c
             write(6,1001) iptr,ixc(iptr),jyc(iptr),
     &                     ityirr(iptr)
c
             do icell=1,ncells(iptr)
                write(6,1003) ar(icell,iptr),
     &                 (qirr(icell,m,iptr),m=1,meqn)
                enddo
             enddo
 919      continue
          write(6,*) '-----------------------------------------'
      endif  
c
c     # solutions from tracked interfaces
      kfront = lstfrt
      do 90 ifr=1,maxfr
         kfront = nxtfront(kfront)
	 if (kfront .eq. 0) go to 99
	 if (newfront(kfront) .eq. 1) go to 90 
         kbond = lstbond(kfront)
         do ibd=1,maxbd
	    kbond = iabs(nxtbond(kbond))
	    if (kbond .eq. 0) go to 90
            ix = ixbond(kbond)
            jy = jybond(kbond)
	    x1 = points(1,1,kbond)
	    y1 = points(1,2,kbond)
	    x2 = points(2,1,kbond)
            y2 = points(2,2,kbond)
            alf  = alfbond(kbond) 
            beta = betabond(kbond)
	    iptr = irrold(ix,jy)
c
            do 80 mw=1,mwave
c
c              # for numerical stability
               if (dabs(sfront(kbond,mw)) .lt. tol) go to 80
c
               dxi = sfront(kbond,mw)*dt
               dnx = alf*dxi
               dny = beta*dxi
c
               if (dxi .gt. 0.d0) then
                   idir = 1
               else
                   idir = -1
               endif
c
               do msubw=1,mwave
                  if (dxi .gt. 0.d0) then
                      do m=1,meqn
                         work(m) = -qjtfront(kbond,m,mw,msubw)
                         enddo
                  else
                      do m=1,meqn
                         work(m) = qjtfront(kbond,m,mw,msubw)
                         enddo
                  endif
c
                  deta = stfront(kbond,mw,msubw)*dt
                  dtx  = beta*deta
                  dty  = -alf*deta
c
                  ddx = dnx+dtx
                  ddy = dny+dty
c
c                 # construct wave polygon (going clockwise)
                  call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,2)
c
                  if (ddx .gt. 0.d0) then
                      i1 = ix
                  else
                      i1 = ix-1
                  endif
                  i2 = i1+1
c
                  if (ddy .gt. 0.d0) then
                      j1 = jy
                  else
                      j1 = jy-1
                  endif
                  j2 = j1+1
c
c                 # update cell values
                  do i=i1,i2
                     do j=j1,j2
                        call irrwv1(i,j,q,qirr,irr,work,pwave,
     &                       mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                       lstgrd)
c
c                       # numerical boundary condition
c                        call nbcwv(i,j,q,qirr,irr,work,pwave,
c     &                       mitot,mjtot,meqn,xlow,ylow,hx,hy,
c     &                       lstgrd,0,2)
                        enddo
                     enddo
                  enddo
 80            continue
            enddo
 90      continue
 99   continue
c
c     # solutions from regular cell interfaces
c     # x-sweep
      do j=mbc,mjtot-mbc+1
         do i=mbc+1,mitot-mbc+1
            iptr = irrold(i,j)
            iptr1 = irrold(i-1,j)
            if ((iabs(iptr) .ne. lstold) .or.
     &          (iabs(iptr1) .ne. lstold)) then
c               # irregular cell case
                if (iabs(iptr) .eq. lstold) then
c                   # right-hand side
c                   # regular cell case
                    x1 = xlow+dfloat(i-1)*hx 
                    y1 = ylow+dfloat(j-1)*hy 
                    x2 = x1
                    y2 = y1+hy
c
                    do m=1,meqn
                       qr(m) = qold(i,j,m)
                       enddo
c
c                   # left-hand side
c                   # irregular cell case
                    do 110 ie0=1,iedge(3,iptr1)
                       y3 = edgp(1,2,3,ie0,iptr1)
                       y4 = edgp(2,2,3,ie0,iptr1)
                       ye0 = dmin1(y2,dmax1(y1,y3))
                       ye1 = dmax1(y1,dmin1(y2,y4))
                       if (dabs(ye0-ye1) .lt. 1.d-10)
     &                     go to 110
c
                       icell = iecell(3,ie0,iptr1)
                       do m=1,meqn
                          ql(m) = qirr(icell,m,iptr1)
                          enddo
c
c                      # update solutions
                       call irrsd(q,qirr,irr,ql,qr,i,j,mitot,mjtot,
     &                      meqn,mwave,xlow,ylow,hx,hy,dt,
     &                      x1,ye0,x2,ye1,1,work,lstgrd) 
 110                   continue
                else
c                   # right-hand side
c                   # irregular cell case
                    do ie=1,iedge(1,iptr)
                       x1 = edgp(1,1,1,ie,iptr)
                       y1 = edgp(1,2,1,ie,iptr)
                       x2 = edgp(2,1,1,ie,iptr)
                       y2 = edgp(2,2,1,ie,iptr)
c
                       icell = iecell(1,ie,iptr)
                       do m=1,meqn
                          qr(m) = qirr(icell,m,iptr)
                          enddo
c
c                      # left-hand side
                       if (iabs(iptr1) .eq. lstold) then
c                          # regular cell case
                           do m=1,meqn
                              ql(m) = qold(i-1,j,m)
                              enddo
c
c                          # update solutions 
                           call irrsd(q,qirr,irr,ql,qr,i,j,mitot,mjtot,
     &                          meqn,mwave,xlow,ylow,hx,hy,dt,
     &                          x1,y1,x2,y2,1,work,lstgrd) 
                       else
c                          # irregular cell case
                           do 120 ie0=1,iedge(3,iptr1)
                              y3 = edgp(1,2,3,ie0,iptr1)
                              y4 = edgp(2,2,3,ie0,iptr1)
                              ye0 = dmin1(y2,dmax1(y1,y3))
                              ye1 = dmax1(y1,dmin1(y2,y4))
                              if (dabs(ye0-ye1) .lt. 1.d-10)
     &                            go to 120
c
                              icell = iecell(3,ie0,iptr1)
                              do m=1,meqn
                                 ql(m) = qirr(icell,m,iptr1)
                                 enddo
c
c                             # update solutions
                              call irrsd(q,qirr,irr,ql,qr,i,j,mitot,
     &                             mjtot,meqn,mwave,xlow,ylow,hx,hy,dt,
     &                             x1,ye0,x2,ye1,1,work,lstgrd) 
 120                          continue
                       endif
                       enddo
                endif
            endif
            enddo
         enddo
c
c     # y-sweep
      do i=mbc,mitot-mbc+1
         do j=mbc+1,mjtot-mbc+1
            iptr = irrold(i,j)
            iptr1 = irrold(i,j-1)
            if ((iabs(iptr) .ne. lstold) .or.
     &          (iabs(iptr1) .ne. lstold)) then
c               # irregular cell case
                if (iabs(iptr) .eq. lstold) then
c                   # right-hand side
c                   # regular cell case
                    x1 = xlow+dfloat(i-1)*hx 
                    y1 = ylow+dfloat(j-1)*hy 
                    x2 = x1+hx
                    y2 = y1
c
                    do m=1,meqn
                       qr(m) = qold(i,j,m)
                       enddo
c
c                   # left-hand side
c                   # irregular cell case
                    do 210 ie0=1,iedge(2,iptr1)
                       x3 = edgp(1,1,2,ie0,iptr1)
                       x4 = edgp(2,1,2,ie0,iptr1)
                       xe0 = dmin1(x2,dmax1(x1,x3))
                       xe1 = dmax1(x1,dmin1(x2,x4))
                       if (dabs(xe0-xe1) .lt. 1.d-10)
     &                     go to 210
c
                       icell = iecell(2,ie0,iptr1)
                       do m=1,meqn
                          ql(m) = qirr(icell,m,iptr1)
                          enddo
c
c                      # update solutions
                       call irrsd(q,qirr,irr,ql,qr,i,j,mitot,mjtot,
     &                      meqn,mwave,xlow,ylow,hx,hy,dt,
     &                      xe0,y1,xe1,y2,2,work,lstgrd) 
 210                   continue
               else
c                   # right-hand side
c                   # irregular cell case
                    do ie=1,iedge(4,iptr)
                       x1 = edgp(1,1,4,ie,iptr)
                       y1 = edgp(1,2,4,ie,iptr)
                       x2 = edgp(2,1,4,ie,iptr)
                       y2 = edgp(2,2,4,ie,iptr)
c
                       icell = iecell(4,ie,iptr)
                       do m=1,meqn
                          qr(m) = qirr(icell,m,iptr)
                          enddo
c
c                      # left-hand side
                       if (iabs(iptr1) .eq. lstold) then
c                          # regular cell case
                           do m=1,meqn
                              ql(m) = qold(i,j-1,m)
                              enddo
c
c                           # update solutions
                            call irrsd(q,qirr,irr,ql,qr,i,j,mitot,
     &                           mjtot,meqn,mwave,xlow,ylow,hx,hy,dt,
     &                           x1,y1,x2,y2,2,work,lstgrd)
                       else
c                           # irregular cell case
                            do 220 ie0=1,iedge(2,iptr1)
                               x3 = edgp(1,1,2,ie0,iptr1)
                               x4 = edgp(2,1,2,ie0,iptr1)
                               xe0 = dmin1(x2,dmax1(x1,x3))
                               xe1 = dmax1(x1,dmin1(x2,x4))
                               if (dabs(xe0-xe1) .lt. 1.d-10)
     &                             go to 220
c
                               icell = iecell(2,ie0,iptr1)
                               do m=1,meqn
                                  ql(m) = qirr(icell,m,iptr1)
                                  enddo
c
c                              # update solutions
                               call irrsd(q,qirr,irr,ql,qr,i,j,mitot,
     &                              mjtot,meqn,mwave,xlow,ylow,hx,hy,
     &                              dt,xe0,y1,xe1,y2,2,work,
     &                              lstgrd)
 220                           continue
                       endif
                       enddo
               endif
            endif
            enddo
         enddo
c
      if (idebug .ne. 0) then
          write(6,*) 'Left pfront routine'
          write(6,*) '------------------------'
          iptr = lstgrd
          do ik=1,maxbd
             iptr = nxtirr(iptr)
             if (iptr .eq. 0) go to 929
c
             write(6,1001) iptr,ixc(iptr),jyc(iptr),
     &                     ityirr(iptr)
c
             do icell=1,ncells(iptr)
                write(6,1003) ar(icell,iptr),
     &                 (qirr(icell,m,iptr),m=1,meqn)
                enddo
             enddo
 929      continue
          write(6,*) '-----------------------------------------'
      endif
c
 1001 format('iptr=',i4,', ix=',i3,', jy=',i3,', type=',i3) 
 1003 format(e12.6,2x,10(e16.5,x)) 
      return
c
      end
