c
c -------------------------------------------------------------------
c
      double precision function philim(a,b,meth)
      implicit double precision (a-h,o-z)
c
c     # Compute a limiter based on wave strengths a and b.
c     # meth determines what limiter is used.
c     # a is assumed to be nonzero.
c
      r = b/a
c
      go to (1,2,3,4,5) meth   
c
 1    continue
c     # Lax-Wendroff limiter
      philim = 1.d0
      return
c
 2    continue
c     # minmod limiter
      philim = dmax1(0.d0, dmin1(1.d0, r))
      return
c
 3    continue
c     # superbee limiter
      philim = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
      return
c
 4    continue
c     # monotonized centered
      philim = dmax1(0.d0, dmin1(2.d0, 2.d0*r, 
     &               .5d0*(1.d0+r)))
      return
c
 5    continue
c     # van Leer
      philim = (r+ dabs(r))/(1.d0+dabs(r))
      return
c
      end
