c
c ---------------------------------------------------------------
c
      subroutine poin2d(p1,p2,p3,area)
      implicit double precision (a-h,o-z)
      common /param/ epsar,hsize,tol
      dimension p1(20,2),p2(20,2),p3(20,2)
      dimension x(20,3),y(20,3)
      logical in,inold
c
c     # Find the intersection of polygons p1 and p2.  
c     # p1: wave, p2: grid cell.
c     # p3: the intersection polygon (which may overwrite
c     #     p1 or p2 if desired).  
c     # The area of the intersection is stored in area.
c     # The intersection is found by intersecting p2 with the half space
c     # determined by the first two vertices of p1.  This polygon is then
c     # intersected with the half space determined by the next two vertices
c     # of p1, and so on.
c     # p2 should be a closed polygon, but p1 need not be.  In particular
c     # p1 may be a half space with only two vertices.  The routine is 
c     # used in this manner to find the intersection of a wave with the
c     # half space generated by a boundary segment, for example.
c
      p3(1,1) = -99.d0
c
c     # smallest of the input wave polygon ?
      area = 0.d0
      do i=1,19
         if (p1(i+1,1) .eq. -99.d0) go to 9
         area = area+((p1(i,2)-p1(1,2))+
     &          (p1(i+1,2)-p1(1,2)))*(p1(i+1,1)-p1(i,1))
         enddo
c
 9    continue
      area = 0.5d0*area
      if (dabs(area) .lt. epsar) then
          area = 0.d0
          return
      endif
c
      area = 0.d0
      do i=1,20
	 x(i,1) = p1(i,1)
	 y(i,1) = p1(i,2)
	 x(i,2) = p2(i,1)
	 y(i,2) = p2(i,2)
         enddo    
c
      ip1 = 1
      ip2 = 2
      ip3 = 3
      do 30 i=1,19
         k = 0
         x(1,ip3) = -99.d0
	 if (x(i+1,ip1) .eq. -99.d0) go to 40
c
	 do j=1,19
	    if(x(j,ip2) .eq. -99.d0) go to 20
c
c           # lefton test (based on sign of area)
	    s = x(j,ip2)*(y(i+1,ip1)-y(i,ip1))+
     &          x(i,ip1)*(y(i,ip1)-y(i+1,ip1))+
     &          x(i+1,ip1)*(y(i,ip1)-y(j,ip2))+
     &          x(i,ip1)*(y(j,ip2)-y(i,ip1))
	    in = s .ge. 0.d0 
            if (j .eq. 1) inold = in
c
	    icase = 1
	    if (in .and. inold) icase = 2
	    if (.not. in .and. .not. inold) icase = 3
	    go to (1,2,3) icase
c
 1          continue
c           # calculate intersection of lines:
            det = x(i,ip1)*(y(j,ip2)-y(j-1,ip2))+
     &            x(i+1,ip1)*(y(j-1,ip2)-y(j,ip2))+
     &            x(j-1,ip2)*(y(i,ip1)-y(i+1,ip1))+
     &            x(j,ip2)*(y(i+1,ip1)-y(i,ip1))
            if (det .eq. 0.d0) go to 2
c
            alf = (x(j-1,ip2)*(y(i,ip1)-y(j,ip2))+
     &             x(i,ip1)*(y(j,ip2)-y(j-1,ip2))+
     &             x(j,ip2)*(y(j-1,ip2)-y(i,ip1)))/det
c
            k = k+1
	    x(k,ip3) = x(i,ip1)+alf*(x(i+1,ip1)-x(i,ip1))
	    y(k,ip3) = y(i,ip1)+alf*(y(i+1,ip1)-y(i,ip1))
c
c           # check closeness
	    if (k .eq. 1) go to 7
	    if ((x(k,ip3) .eq. x(k-1,ip3)) .and. 
     &          (y(k,ip3) .eq. y(k-1,ip3))) k = k-1
 7          continue
	    if (inold) go to 3
c
 2          continue
	    k = k+1
	    x(k,ip3) = x(j,ip2)
	    y(k,ip3) = y(j,ip2)
c
 3          continue
	    inold = in
c	    write(6,*) 'j,in,icase,k,s,det:',j,in,icase,k,s,det
            enddo   
         write(6,*) '*** too many vertices'
         go to 75
c
 20      continue
c        # close the polygon
	 if ((x(k,ip3) .eq. x(1,ip3)) .and. 
     &       (y(k,ip3) .eq. y(1,ip3))) go to 22
         k = k+1
         x(k,ip3) = x(1,ip3)
         y(k,ip3) = y(1,ip3)
c
 22      continue
         x(k+1,ip3) = -99.d0
         ip2 = 5-ip2
         ip3 = 5-ip3
c
c	 write(6,*) 'after intersection with half-space:'
c	 do 25 j=1,k
c 25	    write(6,1001) x(j,ip2),y(j,ip2)
 30      continue
c
 40   continue
      if (x(1,ip2) .eq. -99.d0) return
c
c     # check closeness
      k = 1
      p3(1,1) = x(1,ip2)
      p3(1,2) = y(1,ip2)
      do 70 i=2,20
         if ((x(i,ip2) .eq. p3(k,1)) .and. 
     &       (y(i,ip2) .eq. p3(k,2))) go to 70
	 k = k+1
	 p3(k,1) = x(i,ip2)
	 p3(k,2) = y(i,ip2)
	 if(x(i,ip2) .eq. -99.d0) go to 80
 70      continue
      write(6,*) '*** too many vertices in x'
c
 75   continue
      write(6,*) '   p1:'
      do i=1,10
         write(6,1001) p1(i,1),p1(i,2)
         enddo
c
      write(6,*) '   p2:'
      do i=1,10
         write(6,1001) p2(i,1),p2(i,2)
         enddo
c
      write(6,*) '   p3:'
      do i=1,10
         write(6,1001) p3(i,1),p3(i,2)
         enddo   
c
      write(6,*) '   intersected poly:'
      do i=1,10
         write(6,1001) x(i,ip2),y(i,ip2)
         enddo   
      stop
c
 80   continue
c     # compute area: (twice of the actual area)
      do i=1,19
         if(p3(i+1,1) .eq. -99.d0) go to 99
         area = area+((p3(i,2)-p3(1,2))+
     &          (p3(i+1,2)-p3(1,2)))*(p3(i+1,1)-p3(i,1))
         enddo
c
 99   continue
      area = 0.5d0*area
      if (area .lt. epsar) then
          if (dabs(area) .gt. 1.d-6) then
              write(6,*) 'Error in poin2d: area=',area
              write(6,*) '   p1:'
              do i=1,10
                 write(6,*) p1(i,1),p1(i,2)
                 enddo
c
              write(6,*) '   p2:'
              do i=1,10
                 write(6,*) p2(i,1),p2(i,2)
                 enddo
c
              write(6,*) '   p3:'
              do i=1,10
                 write(6,*) p3(i,1),p3(i,2)
                 enddo
c
              write(6,*) '   intersected poly:'
              do i=1,10
                 write(6,*) x(i,ip2),y(i,ip2)
                 enddo
              stop  
          endif
          area = 0.d0
      endif
c
 1001 format(4e23.8)
      return
      end
