c
c --------------------------------------------------------------
c
      subroutine prmtoc(q,rho,u,v,p,gam0,alp0,bet0,pn0,psi0)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /fluid/ geos(maxfr),alp(maxfr),bet(maxfr),pnf(maxfr),
     &               zf(maxfr),psi(maxfr),mphase  
      dimension q(20)
c
c     # change primitive variables to conservative variables
c
      q(1) = rho
      q(2) = rho*u
      q(3) = rho*v
c
      go to (1,2,3,4) mphase
c
 1    continue
c     # gamma-based version  
c
      q(5) = 1.d0/(gam0-1.d0) 
      q(6) = rho*bet0*q(5)
      q(7) = pn0*(1.d0+q(5)-q(6))
      q(8) = (-1.d0+q(5)-q(6))*alp0*rho*rho 
      q(9) = alp0
      q(10) = psi0
c
      rhoe = (q(5)-q(6))*p+q(7)+q(8)
      q(4) = rhoe+0.5d0*(q(2)*q(2)+q(3)*q(3))/q(1) 
      return
c
 2    continue
c     # gamma-based version
c     # include total kinetic energy
c
      q(5) = 1.d0/(gam0-1.d0)
      q(6) = rho*bet0*q(5)
      q(7) = pn0*(1.d0+q(5)-q(6))
      q(8) = (-1.d0+q(5)-q(6))*alp0*rho*rho 
      q(9) = alp0
c
      q(10) = 0.5d0*(q(2)*q(2)+q(3)*q(3))/q(1)
      q(11) = psi0
c
      rhoe = (q(5)-q(6))*p+q(7)+q(8)
      q(4) = rhoe+q(10)
      return
c
 3    continue
c     # gamma-based version  
c     # version II
c
      q(5) = 1.d0/(gam0-1.d0) 
      q(6) = rho*bet0*q(5)
      q70  = pn0*(1.d0+q(5)-q(6))
      q(7) = q70+(-1.d0+q(5)-q(6))*alp0*rho*rho 
      q(8) = alp0
      q(9) = pn0
      q(10) = psi0
c
      rhoe = (q(5)-q(6))*p+q(7)
      q(4) = rhoe+0.5d0*(q(2)*q(2)+q(3)*q(3))/q(1) 
      return
c
 4    continue
c     # gamma-based version
c     # include total kinetic energy
c     # version II
c
      q(5) = 1.d0/(gam0-1.d0)
      q(6) = rho*bet0*q(5)
      q70 = pn0*(1.d0+q(5)-q(6))
      q(7) = q70+(-1.d0+q(5)-q(6))*alp0*rho*rho
      q(8) = alp0
      q(9) = pn0
c
      q(10) = 0.5d0*(q(2)*q(2)+q(3)*q(3))/q(1)
      q(11) = psi0
c
      rhoe = (q(5)-q(6))*p+q(7)
      q(4) = rhoe+q(10)
      return 
c
      end
