c
c -----------------------------------------------------------------
c
      subroutine rfront(irr,mitot,mjtot,meqn,mwave,lstfrt,work)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /frps/ sfront(maxbd,3),stfront(maxbd,3,3),
     &              qjtfront(maxbd,20,3,3)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /rpsolv/ iriem1,iriem2
      common /tmp/ stan0,stan1,stan2 
      dimension irr(mitot,mjtot),work(meqn)
      dimension ql(20),qr(20)
      dimension s(3),qjump(20,3),qjtmp(20,3),dummy(3)
      data idebug/0/
c
c     # solve Riemann problems at tracked fronts
c
      kfront = lstfrt
      do 100 ifr=1,maxfr
         kfront = iabs(nxtfront(kfront))
         if (kfront .eq. 0) go to 199
c
         mw0 = mwfront(kfront)
c
c        # handle each bond in turn
         kbond = lstbond(kfront)
         do ibd=1,maxbd
            kbond = iabs(nxtbond(kbond))
            if (kbond .eq. 0) go to 100
            ix = ixbond(kbond)
            jy = jybond(kbond)
            iptr = irr(ix,jy)
c
c           # normal direction to the tracked bond
            alf  = alfbond(kbond) 
            beta = betabond(kbond)
c
c           # Riemann data at the front:
            irrl = irrcell(1,kbond)
            irrr = irrcell(2,kbond)
c
            if (itybond(kbond) .eq. 2) then
c               # boundary interface
                do m=1,meqn
                   work(m) = qirr(irrr,m,iptr)
                   enddo
c
                call qrflct(work,alf,beta,meqn)
c
                do m=1,meqn
                   ql(m) = work(m)
                   qr(m) = qirr(irrr,m,iptr)
                   enddo
            else
c               # ordinary tracked interface (eg, shock, contact)
                do m=1,meqn
                   ql(m) = qirr(irrl,m,iptr)
                   qr(m) = qirr(irrr,m,iptr)
                   enddo
            endif
c
c           # resolve Riemann solution in the (alf,beta) direction
            call rprot(ql,qr,s,qjump,work,alf,beta,meqn,mwave,
     &                  dummy,iriem2)
c
c           # tracked front speed
            spbond(1,kbond) = s(mw0)
            spbond(2,kbond) = stan0
c
            do mw=1,mwave
               sfront(kbond,mw) = s(mw)
               enddo
c
            if (idebug .eq. 1) then
                write(6,1003) iptr,ix,jy,kbond,
     &                        irrcell(1,kbond),irrcell(2,kbond)
                write(6,1004) alf,beta
                write(6,1002) (ql(m),m=1,meqn)
                write(6,1002) (qr(m),m=1,meqn)
                do mw=1,mwave
                   write(6,1001) mw,s(mw),(qjump(m,mw),m=1,meqn)
                   enddo
                write(6,1005) stan0
            endif
c
c           # resolve transverse direction wave
            do mw=1,mwave
               do m=1,meqn
                  qr(m) = ql(m)+qjump(m,mw)
                  enddo
c
               call rprot(ql,qr,s,qjtmp,work,beta,-alf,
     &                     meqn,mwave,dummy,iriem2)
c
c              if (mw .eq. mw0) spbond(2,kbond) = s(mw0)
c
               do m=1,meqn
                  ql(m) = qr(m)
                  enddo
c
               do msubw=1,mwave
                  stfront(kbond,mw,msubw) = s(msubw)
                  do m=1,meqn
                     qjtfront(kbond,m,mw,msubw) = qjtmp(m,msubw)
                     enddo
                  enddo
               enddo
            enddo
 100     continue
 199  continue
c
 1001 format('mw=',i3,', s=',e12.6,', qj=',10(e15.6,x))
 1002 format('q=',10(e15.6,x))
 1003 format('iptr=',i4,', ix=',i3,', jy=',i3,', kbond=',i4,
     &       ', icl=',i3,', icr=',i3)
 1004 format('alf=',e12.6,', beta=',e12.6)
 1005 format('tangential speed:', e12.6)
c
      return
      end
