c
c ------------------------------------------------------------------
c
      subroutine rpsect(pstar,
     &                  rhol,ul,pl,gam1,gam10,alp1,bet1,pn1,csql,
     &                  rhor,ur,pr,gam2,gam20,alp2,bet2,pn2,csqr,
     &                  nblow)
      implicit double precision (a-h,o-z)
      data itno/400/, smal/1.d-6/, smalp/1.d-10/
c
c     # Compute mid-state $p^*$ of the Riemann problem
c     # secant iteration version                  
c
      ff(a,b,c,d,e,f) = (a*f+c*d-c*f*(e-b))/(c+f)
c
      nblow = 0
c
c     # set the first initial guess 
      wl = dsqrt(csql)
      wr = dsqrt(csqr)
      pstar = ff(pl,ul,wl,pr,ur,wr)
      pstar = dmax1(pstar,smalp)
      ustar1 = ul+(pl-pstar)/wl
      ustar2 = ur-(pr-pstar)/wr
      pstar0 = pstar
c
c     # set the second initial guess
      call wsqge(wsql,dummy,rho1,pstar,rhol,pl,csql,gam10,
     &           alp1,bet1,pn1)
      wl = dsqrt(wsql)
      call wsqge(wsqr,dummy,rho2,pstar,rhor,pr,csqr,gam20,
     &           alp2,bet2,pn2)
      wr = dsqrt(wsqr)
      pstar = ff(pl,ul,wl,pr,ur,wr)
      pstar = dmax1(pstar,smalp)
c
c     # iterate to find pstar, ustar
      do iter=1,itno
         call wsqge(wsql,dummy,rho1,pstar,rhol,pl,csql,gam10,
     &              alp1,bet1,pn1)
         wl = dsqrt(wsql)
c
         call wsqge(wsqr,dummy,rho2,pstar,rhor,pr,csqr,gam20,
     &              alp2,bet2,pn2)
         wr = dsqrt(wsqr)
c
         ustar10 = ustar1
         ustar20 = ustar2
         ustar1 = ul+(pl-pstar)/wl
         ustar2 = ur-(pr-pstar)/wr
c
         dpi = dabs(pstar-pstar0)
         zl  = dabs(ustar1-ustar10)
         zr  = dabs(ustar2-ustar20)
c
         pstar0 = pstar
         delp = dpi/dmax1(zl+zr,smalp)*(ustar2-ustar1)
         pstar = pstar-delp
	 if(dabs(delp) .lt. smal) return
         pstar = dmax1(pstar,smalp)
         enddo
c
      write(6,*) 'Error in Riemann problem: rpsect:'
      write(6,*) 'delp=',delp,', pstar=',pstar
      write(6,1001) rhol,ul,pl,gam1,bet1,pn1
      write(6,1001) rhor,ur,pr,gam2,bet2,pn2
      nblow = 1
      return
c
 1001 format(6(e18.6,x)) 
      end
