c
c ------------------------------------------------------------------------
c
      subroutine setbdc(iptr)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension sign(6),ineg(6),ipos(6)
c   
c     # set bond-cells correspondence
c
      if (nbonds(iptr) .ne. 1) go to 10
c
c     # single bond case
      kbond = nbondc(1,iptr)
      irrcell(1,kbond) = 1
      irrcell(2,kbond) = 2
      go to 60
c
 10   continue
c     # multiple bond case
      do 50 ibd=1,nbonds(iptr)
	 kbond = nbondc(ibd,iptr)
	 ip0 = 0
	 ip1 = 0
	 do icell=1,ncells(iptr)
            sign(icell) = area2(points(1,1,kbond),points(1,2,kbond),
     &                          points(2,1,kbond),points(2,2,kbond),
     &                          xcen(icell,iptr),
     &                          ycen(icell,iptr))
	    if (sign(icell) .lt. 0.d0) then
c               # post-shock subcell
		ip0 = ip0+1
		ineg(ip0) = icell
	    else
c               # pre-shock subcell
		ip1 = ip1+1
		ipos(ip1) = icell
	    endif
            enddo
c
c        # set post-shock bond-cell info
         if (itybond(kbond) .eq. 2) go to 39
         do 35 i=1,ip0
            do ii=1,10
               if(poly(ineg(i),ii+1,1,iptr) .eq. -99.d0) go to 35
               iscell = icheck(points(1,1,kbond),points(1,2,kbond),
     &                         points(2,1,kbond),points(2,2,kbond),
     &                         poly(ineg(i),ii,1,iptr),
     &                         poly(ineg(i),ii,2,iptr),
     &                         poly(ineg(i),ii+1,1,iptr),
     &                         poly(ineg(i),ii+1,2,iptr))
               if (iscell .eq. 1) go to 39
               enddo
 35         continue
         write(6,*) 'post-shock state'
	 go to 90
 39      irrcell(1,kbond) = ineg(i)
c
c        # set pre-shock bond-cell info
         do 45 i=1,ip1
	    do ii=1,10
               if(poly(ipos(i),ii+1,1,iptr) .eq. -99.d0) go to 45
               iscell = icheck(points(1,1,kbond),points(1,2,kbond),
     &                         points(2,1,kbond),points(2,2,kbond),
     &                         poly(ipos(i),ii,1,iptr),
     &                         poly(ipos(i),ii,2,iptr),
     &                         poly(ipos(i),ii+1,1,iptr),
     &                         poly(ipos(i),ii+1,2,iptr))
               if (iscell .eq. 1) go to 49
               enddo
 45         continue
         write(6,*) 'pre-shock state'
	 go to 90
 49      irrcell(2,kbond) = ipos(i)
 50      continue
c
 60   continue
      return
c
 90   continue
      write(6,1004) iptr,kbond,ixbond(kbond),jybond(kbond),
     &              ityirr(iptr)
      write(6,*) points(1,1,kbond),points(1,2,kbond),
     &              points(2,1,kbond),points(2,2,kbond)
      do ibd=1,nbonds(iptr)
	 kbond = nbondc(ibd,iptr)
	 write(6,1001) kbond,irrcell(1,kbond),irrcell(2,kbond),
     &                 itybond(kbond)
	 write(6,1002) points(1,1,kbond),points(1,2,kbond),
     &                 points(2,1,kbond),points(2,2,kbond)
         enddo
c
      do 96 icell=1,ncells(iptr)
         write(6,1003) icell,ar(icell,iptr),xcen(icell,iptr),
     &                 ycen(icell,iptr),sign(icell)
         do ii=1,10
            if (poly(icell,ii,1,iptr) .eq. -99.d0) 
     &	        go to 96 
            write(6,*) (poly(icell,ii,jj,iptr),jj=1,2)
            enddo
 96      continue
c
 1001 format('kbond=',i3,', icl=',i3,', icr=',i3,', itype=',i3)
 1002 format(4f12.6)
 1003 format('icell=',i3,', area=',e12.6,', xcen=',e12.6,
     &       ', ycen=',e12.6,', sign=',e12.6)
 1004 format('ERROR in setbdc: iptr=',i3,', kbond=',i3,
     &       ', ix=',i3,', jy=',i3, ', itype=',i3)
      stop
c
      end
