c
c -------------------------------------------------------------------
c
      subroutine setqir(irr,mitot,mjtot,meqn,lstgrd,lstfrt,
     &                  time,work,iprob)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /frontin/ xloop(maxfr),yloop(maxfr),rloop(maxfr),
     &       varloop(5,maxfr,maxfr),stdev(maxfr),ityloop(maxfr),
     &       ibdloop(maxfr),mwloop(maxfr),istloop(maxfr),
     &       newloop(maxfr),nloops,nfourier(maxfr),nrand(maxfr) 
      common /intf0/ posn(2),dir(2),radius,iprobs
      common /init0/ rhol,ul,vl,pl,rhom,um,vm,pm,rhor,ur,vr,pr
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /setqm/ qmult(2,20,maxfr)
      dimension irr(mitot,mjtot),work(meqn)
c
c     # set values for irregular cells
c
      go to (1,2) iprob
c 
 1    continue
c     # a two-phase gas-liquid problem
c     # underwater explosion (in cylindrical symmetry)
c
      iloop = 0
      kfront = lstfrt
      do 105 ifr=1,maxfr
         kfront = iabs(nxtfront(kfront))
         if (kfront .eq. 0) go to 109
c
c        # handle each bond in turn
         iloop = iloop+1
         kbond = lstbond(kfront)
         do ibd=1,maxbd
            kbond = iabs(nxtbond(kbond))
            if (kbond .eq. 0) go to 105
            ix = ixbond(kbond)
            jy = jybond(kbond)
            iptr = irr(ix,jy) 
c
            kbond = nbondc(1,iptr)
            irrl = irrcell(1,kbond)
            irrr = irrcell(2,kbond)
            do m=1,meqn
                qirr(irrl,m,iptr) = qmult(1,m,iloop)
                qirr(irrr,m,iptr) = qmult(2,m,iloop)
                enddo
            enddo
 105     continue
 109  continue
      go to 990
c
 2    continue
c     # bubble evolution
      kfront = lstfrt
      do 405 ifr=1,maxfr
         kfront = iabs(nxtfront(kfront))
         if (kfront .eq. 0) go to 409
c
c        # handle each bond in turn
         kbond = lstbond(kfront)
         do ibd=1,maxbd
            kbond = iabs(nxtbond(kbond))
            if (kbond .eq. 0) go to 405
            ix = ixbond(kbond)
            jy = jybond(kbond)
            iptr = irr(ix,jy) 
c
            kbond = nbondc(1,iptr)
            irrl = irrcell(1,kbond)
            irrr = irrcell(2,kbond)
            do m=1,meqn
                qirr(irrl,m,iptr) = qmult(1,m,1)
                qirr(irrr,m,iptr) = qmult(2,m,1)
                enddo
            enddo
 405     continue
 409  continue
      go to 990
c 
 990  continue
c
      return
      end
