c
c ---------------------------------------------------------------
c
      subroutine source(q,irr,mitot,mjtot,meqn,dt,lstgrd,iorder,
     &                  work)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /sterms/ gravc(2),nsource,isource(10),igeom   
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot),work(meqn)  
      dimension g(20),gprev(20)
c
c     # handle source terms
c
      dt2 = dt
      if (iorder .eq. 2) dt2 = 0.5d0*dt
c
      do 900 isour=1,nsource
	 go to (1,2,3,4) isource(isour)
c
 1       continue
c        # geometric source terms
         do i=1,mitot
            r0 = xlow+(dfloat(i-1)+0.5d0)*hx    
            do j=1,mjtot
               if (iabs(irr(i,j)) .ne. lstgrd) then
                   iptr = irr(i,j)
                   do icell=1,ncells(iptr)
                      do m=1,meqn
                         work(m) = qirr(icell,m,iptr)
                         enddo
c
                      r0 = xcen(icell,iptr)
                      gfrac = -fpgeom(r0)/fgeom(r0)  
c
                      call ctoprm(work,rho,u,v,rhoe,rhok,p,
     &                            gamma,gru0,gam0,alp0,bet0,pn0,
     &                            psi0) 
c
                      if (iorder .eq. 1) then
c                         # first order ODE solver
                          call gsrc(g,gfrac,rho,u,v,rhoe,rhok,p,
     &                              gam0,alp0,bet0,pn0)
c
                          do m=1,meqn
                             qirr(icell,m,iptr) = qirr(icell,m,iptr)+
     &                                                 dt2*g(m)
                             enddo
                      else
c                         # second order ODE solver
                          call gsrc(gprev,gfrac,rho,u,v,rhoe,rhok,p,
     &                              gam0,alp0,bet0,pn0)
c
                          do m=1,meqn
                             work(m) = work(m)+dt2*gprev(m)
                             enddo
                          call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                                gru0,gam0,alp0,bet0,pn0,psi0) 
c
                          call gsrc(g,gfrac,rho,u,v,rhoe,rhok,p,
     &                              gam0,alp0,bet0,pn0)
c
                          do m=1,meqn
                             qirr(icell,m,iptr) = qirr(icell,m,iptr)+
     &                                       .5d0*dt2*(g(m)+gprev(m))
                             enddo
                      endif         
                      enddo
               else
                   do m=1,meqn
                      work(m) = q(i,j,m)
                      enddo
c
                   gfrac = -fpgeom(r0)/fgeom(r0)  
                   call ctoprm(work,rho,u,v,rhoe,rhok,p,
     &                         gamma,gru0,gam0,alp0,bet0,pn0,
     &                         psi0) 
c
                   if (iorder .eq. 1) then
c                      # first order ODE solver
                       call gsrc(g,gfrac,rho,u,v,rhoe,rhok,p,
     &                           gam0,alp0,bet0,pn0)
c
                       do m=1,meqn
                          q(i,j,m) = q(i,j,m)+dt2*g(m)
                          enddo
                   else
c                      # second order ODE solver
                       call gsrc(gprev,gfrac,rho,u,v,rhoe,rhok,p,
     &                           gam0,alp0,bet0,pn0)
c
                       do m=1,meqn
                          work(m) = work(m)+dt2*gprev(m)
                          enddo
                       call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                             gru0,gam0,alp0,bet0,pn0,psi0) 
c
                       call gsrc(g,gfrac,rho,u,v,rhoe,rhok,p,
     &                           gam0,alp0,bet0,pn0)
c
                       do m=1,meqn
                          q(i,j,m) = q(i,j,m)+.5d0*dt2*(g(m)+gprev(m))
                          enddo
                   endif         
               endif
               enddo
            enddo
         go to 900
c
 2       continue
c        # gravitational source terms
         do i=1,mitot
            do j=1,mjtot
               if (iabs(irr(i,j)) .ne. lstgrd) then
                   iptr = irr(i,j)
                   do icell=1,ncells(iptr)
                      if (iorder .eq. 1) then
c                         # first order ODE solver
c
                          g(2) = qirr(icell,1,iptr)*gravc(1)
                          g(3) = qirr(icell,1,iptr)*gravc(2)
                          g(4) = qirr(icell,2,iptr)*gravc(1)+
     &                           qirr(icell,3,iptr)*gravc(2)
                          do m=2,4
                             qirr(icell,m,iptr) = 
     &                                  qirr(icell,m,iptr)+dt2*g(m)
                             enddo
                      else
c                         # second order ODE solver
c
                          gprev(2) = qirr(icell,1,iptr)*gravc(1)
                          gprev(3) = qirr(icell,1,iptr)*gravc(2)
                          gprev(4) = qirr(icell,2,iptr)*gravc(1)+
     &                               qirr(icell,3,iptr)*gravc(2)
                          do m=2,4
                             work(m) = qirr(icell,m,iptr)+
     &                                     dt2*gprev(m)
                             enddo
c
                          g(2) = qirr(icell,1,iptr)*gravc(1)
                          g(3) = qirr(icell,1,iptr)*gravc(2)
                          g(4) = work(2)*gravc(1)+work(3)*gravc(2)
                          do m=2,4
                             qirr(icell,m,iptr) = qirr(icell,m,iptr)+
     &                                 .5d0*dt2*(g(m)+gprev(m))
                             enddo
                      endif
                      enddo
               else
                   if (iorder .eq. 1) then
c                      # first order ODE solver
c
                       g(2) = q(i,j,1)*gravc(1)
                       g(3) = q(i,j,1)*gravc(2)
                       g(4) = q(i,j,2)*gravc(1)+q(i,j,3)*gravc(2)
                       do m=2,4
                          q(i,j,m) = q(i,j,m)+dt2*g(m)
                          enddo
                   else
c                      # second order ODE solver
c
                       gprev(2) = q(i,j,1)*gravc(1)
                       gprev(3) = q(i,j,1)*gravc(2)
                       gprev(4) = q(i,j,2)*gravc(1)+q(i,j,3)*gravc(2)
                       do m=2,4
                          work(m) = q(i,j,m)+dt2*gprev(m)
                          enddo
c
                       g(2) = q(i,j,1)*gravc(1)
                       g(3) = q(i,j,1)*gravc(2)
                       g(4) = work(2)*gravc(1)+work(3)*gravc(2)
                       do m=2,4
                          q(i,j,m) = q(i,j,m)+.5d0*dt2*(g(m)+gprev(m))
                          enddo
                   endif
               endif
               enddo
            enddo
	 go to 900
c
 3       continue
c        # reacting source terms
	 go to 900
c
 4       continue
c        # radiation source terms
         go to 900
 900     continue
c
      return   
      end
