c
c ------------------------------------------------------------------
c
      subroutine vartme(q,irr,mitot,mjtot,meqn,hx,hy,time,
     &                  nstep,dt,work,cfl,lstgrd)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension q(mitot,mjtot,meqn),irr(mitot,mjtot)
      dimension work(meqn)
c
c     # compute variable time step with CFL restriction
c
      cmax = 0.d0
c
      do i=1,mitot  
         do j=1,mjtot  
            if (iabs(irr(i,j)) .ne. lstgrd) then
                iptr = irr(i,j)
                do icell=1,ncells(iptr)
                   do m=1,meqn
                     work(m) = qirr(icell,m,iptr)
                     enddo
c
                   call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                         gruen,gam0,alp0,bet0,pn0,psi)
c
                   c2 = gamma*(p+pn0)/rho+(gamma-2.d0)*alp0*rho 
                   if (c2 .le. 0.d0) then
                       write(6,*) 'Error in vartme: c2=',c2
                       write(6,*) 'i=',i,', j=',j,', icel=',icell
                       write(6,*) rho,p,gam0,alp0,bet0,pn0
                       stop
                   endif
c
                   c = dsqrt(c2)
                   cmax = dmax1(cmax,dabs(u)+c,dabs(v)+c)
                   enddo
            else
                if (irr(i,j) .ne. -lstgrd) then
                    do m=1,meqn
                       work(m) = q(i,j,m)
                       enddo
c
                    call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                          gruen,gam0,alp0,bet0,pn0,psi)
c
                    c2 = gamma*(p+pn0)/rho+(gamma-2.d0)*alp0*rho 
                    if (c2 .le. 0.d0) then
                        write(6,*) 'Error in vartme: c2=',c2
                        write(6,*) 'i=',i,', j=',j
                        write(6,*) rho,p,gam0,alp0,bet0,pn0
                        stop
                    endif
c
                    c = dsqrt(c2)
                    cmax = dmax1(cmax,dabs(u)+c,dabs(v)+c)
                endif
            endif
            enddo
         enddo
c
      if (cmax .ne. 0.d0) dt = cfl*dmin1(hx,hy)/cmax
c
      return
      end
