c
c ------------------------------------------------------------------
c
      subroutine vofem(i,j,vof,mitot,mjtot,xlow,ylow,hx,hy,alf,beta)
      implicit double precision (a-h,o-z)
      common /vof0/ ivof,iflow,mw0  
      dimension vof(mitot,mjtot)
c
c     # compute normal direction of an interface  
c     # within cell (i,j)
c
      go to (1,2,3,4,5) ivof
c
 1    continue
c     # Saltzman: center of mass
      sumvof = 0.d0
      xm = 0.d0
      ym = 0.d0
      do m=-1,1
         xc = xlow+dfloat(i+m-0.5d0)*hx 
         do n=-1,1
            yc = ylow+dfloat(j+n-0.5d0)*hy 
            xm = xm+xc*vof(i+m,j+n)
            ym = ym+yc*vof(i+m,j+n)
c
            sumvof = sumvof+vof(i+m,j+n)
            enddo
         enddo
c
      xm = xm/sumvof
      ym = ym/sumvof
c
      xc = xlow+dfloat(i-0.5d0)*hx 
      yc = ylow+dfloat(j-0.5d0)*hy 
      alf  = xc-xm
      beta = yc-ym
      sqrtm = dsqrt(alf**2+beta**2)
      alf  = alf/sqrtm
      beta = beta/sqrtm
      return
c
 2    continue
c     # Parker-Youngs
      vofe = .25d0*(vof(i+1,j-1)+2.d0*vof(i+1,j)+vof(i+1,j+1))
      vofw = .25d0*(vof(i-1,j-1)+2.d0*vof(i-1,j)+vof(i-1,j+1))
      vofn = .25d0*(vof(i-1,j+1)+2.d0*vof(i,j+1)+vof(i+1,j+1))
      vofs = .25d0*(vof(i-1,j-1)+2.d0*vof(i,j-1)+vof(i+1,j-1))
      alf  = .5d0*(vofe-vofw)
      beta = .5d0*(vofn-vofs)
      sqrtm = dsqrt(alf**2+beta**2)
      alf  = -alf/sqrtm
      beta = -beta/sqrtm
      return
c
 3    continue
c     # Hirt-Nichols: central difference
      vofe = vof(i+1,j-1)+vof(i+1,j)+vof(i+1,j+1)
      vofw = vof(i-1,j-1)+vof(i-1,j)+vof(i-1,j+1)
      vofn = vof(i-1,j+1)+vof(i,j+1)+vof(i+1,j+1)
      vofs = vof(i-1,j-1)+vof(i,j-1)+vof(i+1,j-1)
      alf  = .5d0*(vofe-vofw)
      beta = .5d0*(vofn-vofs)
      sqrtm = dsqrt(alf**2+beta**2)
      alf  = -alf/sqrtm
      beta = -beta/sqrtm
      return
c
 4    continue
c     # Pilliod-Puckett: "fast" least squares
      return
c
 5    continue
      return
c
      end
