c
c -----------------------------------------------------------------
c
      subroutine vofnst(vof,vofold,qold,irrold,ul,ur,s,
     &                  mitot,mjtot,mmax,meqn,mwave,xlow,ylow,
     &                  hx,hy,dt,mbc,lstold,lstfrt,work)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkedge/ iedge(4,maxbd),iecell(4,6,maxbd),
     &                edgp(2,2,4,6,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /param/ epsar,hsize,tol
      common /vof0/ ivof,iflow,mw0
      dimension vof(mitot,mjtot),vofold(mitot,mjtot)
      dimension qold(mitot,mjtot,meqn),irrold(mitot,mjtot)
      dimension work(meqn),ul(mmax,meqn),ur(mmax,meqn)
      dimension s(mmax,mwave)
      dimension pwave(20,2),p1(20,2),dummy(20,2)
      dimension ql(20),qr(20)
      data ixrp/1/,jyrp/0/
c
c     # update volume of fluid to the next time step
c
      area0 = hx*hy
c
c     # solutions from tracked interfaces
      kfront = lstfrt
      do 90 ifr=1,maxfr
         kfront = nxtfront(kfront)
	 if (kfront .eq. 0) go to 99
	 if (newfront(kfront) .eq. 1) go to 90 
         kbond = lstbond(kfront)
         do 80 ibd=1,maxbd
	    kbond = iabs(nxtbond(kbond))
	    if (kbond .eq. 0) go to 90
c
c           # for numerical stability
            if (dabs(spbond(1,kbond)) .lt. tol) go to 80
c
            alf  = alfbond(kbond) 
            beta = betabond(kbond)
            dxi  = spbond(1,kbond)*dt
            dnx  = alf*dxi
            dny  = beta*dxi
c
            deta = spbond(2,kbond)*dt
            dtx  = beta*deta
            dty  = -alf*deta
c
            ddx  = dnx+dtx
            ddy  = dny+dty
c
            irrl = irrcell(1,kbond)
            irrr = irrcell(2,kbond)
            ix   = ixbond(kbond)
            jy   = jybond(kbond)
            iptr = irrold(ix,jy) 
            work(1) = vofir(irrr,iptr)-vofir(irrl,iptr)
c
            if (dxi .gt. 0.d0) then
                idir = 1
                work(1) = -work(1) 
            else
                idir = -1
            endif
c
c           # construct wave polygon (going clockwise)
            x1 = points(1,1,kbond)
            y1 = points(1,2,kbond)
            x2 = points(2,1,kbond)
            y2 = points(2,2,kbond) 
            call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,2)
c
            if (ddx .gt. 0.d0) then
                i1 = ix
            else
                i1 = ix-1
            endif
            i2 = i1+1
c
            if (ddy .gt. 0.d0) then
                j1 = jy
            else
                j1 = jy-1
            endif
            j2 = j1+1
c
c           # update cell values
            do i=i1,i2
               do j=j1,j2
                  xi = xlow+dfloat(i-1)*hx
                  yj = ylow+dfloat(j-1)*hy
                  p1(1,1) = xi
                  p1(1,2) = yj
                  p1(2,1) = xi
                  p1(2,2) = yj+hy
                  p1(3,1) = xi+hx
                  p1(3,2) = yj+hy
                  p1(4,1) = xi+hx
                  p1(4,2) = yj
                  p1(5,1) = xi
                  p1(5,2) = yj
                  p1(6,1) = -99.d0
                  p1(6,2) = -99.d0 
c
                  call poin2d(pwave,p1,dummy,area)
                  vof(i,j) = vof(i,j)+area/area0*work(1)
                  enddo
               enddo
 80         continue
 90      continue
 99   continue
c
c     # solutions from regular cell interfaces
c     # x-sweep
      do j=mbc,mjtot-mbc+1
c        # compute flow velocity
c
         do m=1,meqn
            do i=2,mitot
               ul(i,m) = qold(i-1,j,m)
               ur(i,m) = qold(i,j,m)
               enddo
            enddo
c
         call vflow(ul,ur,s,work,2,mitot,mmax,meqn,mwave,
     &              ixrp,iflow,mw0)
c
c        # update solution
         do 190 i=mbc+1,mitot-mbc+1
            iptr  = irrold(i,j)
            iptr1 = irrold(i-1,j)
            if ((iabs(iptr) .eq. lstold) .and.
     &          (iabs(iptr1) .eq. lstold)) then
c               # regular cell case
c
                work(1) = vofold(i,j)-vofold(i-1,j)
                if (dabs(work(1)) .lt. tol) go to 190
c
                ddx = s(i,1)*dt
                ddy = s(i,2)*dt
                tria = 0.5d0*dabs(ddx*ddy)
c
                if (ddx .gt. 0.d0) then
                    ix0 = i
                    work(1) = -work(1) 
                else
                    ix0 = i-1
                endif
c
                vof(ix0,j) = vof(ix0,j)+(hy*dabs(ddx)-tria)/
     &                       area0*work(1)
c
                if (ddy .gt. 0.d0) then
                    jy0 = j+1
                else
                    jy0 = j-1
                endif
c
                if ((jy0 .ge. 1) .and. (jy0 .le. mjtot)) 
     &              vof(ix0,jy0) = vof(ix0,jy0)+tria/area0*work(1)
            else
c               # irregular cell case
                if (iabs(iptr) .eq. lstold) then
c                   # right-hand side
c                   # regular cell case
                    x1 = xlow+dfloat(i-1)*hx 
                    y1 = ylow+dfloat(j-1)*hy
                    x2 = x1
                    y2 = y1+hy
c
                    do m=1,meqn
                       qr(m) = qold(i,j,m)
                       enddo
                    vof2 = vofold(i,j)
c
c                   # left-hand side
c                   # irregular cell case
                    do 110 ie0=1,iedge(3,iptr1)
                       y3 = edgp(1,2,3,ie0,iptr1)
                       y4 = edgp(2,2,3,ie0,iptr1)
                       ye0 = dmin1(y2,dmax1(y1,y3))
                       ye1 = dmax1(y1,dmin1(y2,y4))
                       if (dabs(ye0-ye1) .lt. 1.d-10)
     &                     go to 110
c
                       icell = iecell(3,ie0,iptr1)
                       do m=1,meqn
                          ql(m) = qirr(icell,m,iptr1)
                          enddo
                       vof1 = vofir(icell,iptr1)
c
c                      # update solutions
                       call vofsd(vof,ql,qr,vof1,vof2,i,j,mitot,
     &                      mjtot,meqn,xlow,ylow,hx,hy,
     &                      dt,area0,x1,ye0,x2,ye1,1) 
 110                   continue
                else
c                   # right-hand side
c                   # irregular cell case
                    do ie=1,iedge(1,iptr)
                       x1 = edgp(1,1,1,ie,iptr)
                       y1 = edgp(1,2,1,ie,iptr)
                       x2 = edgp(2,1,1,ie,iptr)
                       y2 = edgp(2,2,1,ie,iptr)
c
                       icell = iecell(1,ie,iptr)
                       do m=1,meqn
                          qr(m) = qirr(icell,m,iptr)
                          enddo
                       vof2 = vofir(icell,iptr)
c
c                      # left-hand side
                       if (iabs(iptr1) .eq. lstold) then
c                          # regular cell case
                           do m=1,meqn
                              ql(m) = qold(i-1,j,m)
                              enddo
                           vof1 = vofold(i-1,j)
c
c                          # update solutions 
                           call vofsd(vof,ql,qr,vof1,vof2,i,j,mitot,
     &                          mjtot,meqn,xlow,ylow,hx,hy,
     &                          dt,area0,x1,y1,x2,y2,1)
                       else
c                          # irregular cell case
                           do 120 ie0=1,iedge(3,iptr1)
                              y3 = edgp(1,2,3,ie0,iptr1)
                              y4 = edgp(2,2,3,ie0,iptr1)
                              ye0 = dmin1(y2,dmax1(y1,y3))
                              ye1 = dmax1(y1,dmin1(y2,y4))
                              if (dabs(ye0-ye1) .lt. 1.d-10)
     &                            go to 120
c
                              icell = iecell(3,ie0,iptr1)
                              do m=1,meqn
                                 ql(m) = qirr(icell,m,iptr1)
                                 enddo
                              vof1 = vofir(icell,iptr1)
c
c                             # update solutions
                              call vofsd(vof,ql,qr,vof1,vof2,i,j,
     &                             mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                             dt,area0,x1,ye0,x2,ye1,1)
 120                          continue
                       endif
                       enddo
                endif
            endif
  190       continue
         enddo
c
c     # y-sweep
      do i=mbc,mitot-mbc+1
         do m=1,meqn
            do j=2,mjtot
               ul(j,m) = qold(i,j-1,m)
               ur(j,m) = qold(i,j,m)
               enddo
            enddo
c
         call vflow(ul,ur,s,work,2,mjtot,mmax,meqn,mwave,
     &              jyrp,iflow,mw0)
c
         do 290 j=mbc+1,mjtot-mbc+1
            iptr = irrold(i,j)
            iptr1 = irrold(i,j-1)
            if ((iabs(iptr) .eq. lstold) .and.
     &          (iabs(iptr1) .eq. lstold)) then
c               # regular cell case
c
                work(1) = vofold(i,j)-vofold(i,j-1)
                if (dabs(work(1)) .lt. tol) go to 290
c
                ddy = s(j,1)*dt
                ddx = s(j,2)*dt
                tria = 0.5d0*dabs(ddx*ddy)
c
                if (ddy .gt. 0.d0) then
                    jy0 = j
                    work(1) = -work(1)  
                else
                    jy0 = j-1
                endif
c
                vof(i,jy0) = vof(i,jy0)+(hx*dabs(ddy)-tria)/
     &                       area0*work(1)
c
                if (ddx .gt. 0.d0) then
                    ix0 = i+1
                else
                    ix0 = i-1
                endif
c
                if ((ix0 .ge. 1) .and. (ix0 .le. mitot)) 
     &              vof(ix0,jy0) = vof(ix0,jy0)+tria/area0*work(1)
            else
c               # irregular cell case
                if (iabs(iptr) .eq. lstold) then
c                   # right-hand side
c                   # regular cell case
                    x1 = xlow+dfloat(i-1)*hx
                    y1 = ylow+dfloat(j-1)*hy
                    x2 = x1+hx
                    y2 = y1
c
                    do m=1,meqn
                       qr(m) = qold(i,j,m)
                       enddo
                    vof2 = vofold(i,j)
c
c                   # left-hand side
                    iptr1 = irrold(i,j-1)
                    do 210 ie0=1,iedge(2,iptr1)
                       x3 = edgp(1,1,2,ie0,iptr1)
                       x4 = edgp(2,1,2,ie0,iptr1)
                       xe0 = dmin1(x2,dmax1(x1,x3))
                       xe1 = dmax1(x1,dmin1(x2,x4))
                       if (dabs(xe0-xe1) .lt. 1.d-10)
     &                     go to 210
c
                       icell = iecell(2,ie0,iptr1)
                       do m=1,meqn
                          ql(m) = qirr(icell,m,iptr1)
                          enddo
                       vof1 = vofir(icell,iptr1)
c
c                      # update solutions
                       call vofsd(vof,ql,qr,vof1,vof2,i,j,mitot,
     &                            mjtot,meqn,xlow,ylow,hx,hy,
     &                            dt,area0,xe0,y1,xe1,y2,2)
 210                   continue
               else
c                   # right-hand side
c                   # irregular cell case
                    do ie=1,iedge(4,iptr)
                       x1 = edgp(1,1,4,ie,iptr)
                       y1 = edgp(1,2,4,ie,iptr)
                       x2 = edgp(2,1,4,ie,iptr)
                       y2 = edgp(2,2,4,ie,iptr)
c
                       icell = iecell(4,ie,iptr)
                       do m=1,meqn
                          qr(m) = qirr(icell,m,iptr)
                          enddo
                       vof2 = vofir(icell,iptr)
c
c                      # left-hand side
                       if (iabs(iptr1) .eq. lstold) then
c                          # regular cell case
                           do m=1,meqn
                              ql(m) = qold(i,j-1,m)
                              enddo
                           vof1 = vofold(i,j-1)
c
c                           # update solutions
                            call vofsd(vof,ql,qr,vof1,vof2,i,j,
     &                           mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                           dt,area0,x1,y1,x2,y2,2)
                       else
c                           # irregular cell case
                            do 220 ie0=1,iedge(2,iptr1)
                               x3 = edgp(1,1,2,ie0,iptr1)
                               x4 = edgp(2,1,2,ie0,iptr1)
                               xe0 = dmin1(x2,dmax1(x1,x3))
                               xe1 = dmax1(x1,dmin1(x2,x4))
                               if (dabs(xe0-xe1) .lt. 1.d-10)
     &                             go to 220
c
                               icell = iecell(2,ie0,iptr1)
                               do m=1,meqn
                                  ql(m) = qirr(icell,m,iptr1)
                                  enddo
                               vof1 = vofir(icell,iptr1)
c
c                              # update solutions
                               call vofsd(vof,ql,qr,vof1,vof2,i,j,
     &                              mitot,mjtot,meqn,xlow,ylow,hx,hy,
     &                              dt,area0,xe0,y1,xe1,y2,2)
 220                           continue
                       endif
                       enddo
               endif
            endif
 290        continue
         enddo
c
      return
      end
