c
c -----------------------------------------------------------------
c
      subroutine vofsd(vof,ql,qr,vof1,vof2,i,j,mitot,mjtot,meqn,
     &                 xlow,ylow,hx,hy,dt,area0,x1,y1,x2,y2,iface)
      implicit double precision (a-h,o-z)
      common /param/ epsar,hsize,tol
      common /vof0/ ivof,iflow,mw0
      dimension vof(mitot,mjtot),ql(20),qr(20)
      dimension pwave(20,2),p1(20,2),dummy(20,2)   
      data ixrp/1/,jyrp/0/
c
c     # update solutions using waves from irregular cell side
c
      work = vof2-vof1
      if (dabs(work) .lt. tol) return
c
      go to (1,2) iface
c
 1    continue
c     # vertical face:
c     ---------------
c     # compute flow velocity     
      call flow(ql,qr,sn,st,meqn,ixrp,iflow,mw0)
c
      if (dabs(sn) .le. tol) return
c
      ddx = sn*dt
      ddy = st*dt
c
      if (sn .gt. 0.d0) then
          ix0 = i
          idir = 1
          work = -work
      else
          ix0 = i-1
          idir = -1
      endif
c
c     # construct wave polygon (going clockwise)
      call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,1)
c
c     # construct grid polygon
      xi = xlow+dfloat(ix0-1)*hx
      yj = ylow+dfloat(j-1)*hy
      p1(1,1) = xi
      p1(1,2) = yj
      p1(2,1) = xi
      p1(2,2) = yj+hy
      p1(3,1) = xi+hx
      p1(3,2) = yj+hy
      p1(4,1) = xi+hx
      p1(4,2) = yj
      p1(5,1) = xi
      p1(5,2) = yj
      p1(6,1) = -99.d0
      p1(6,2) = -99.d0
c
      call poin2d(pwave,p1,dummy,area) 
      vof(ix0,j) = vof(ix0,j)+area/area0*work
c
      if (ddy .gt. 0.d0) then
          jy0 = j+1
      else
          jy0 = j-1
      endif
c
      if ((jy0 .ge. 1) .and. (jy0 .le. mjtot)) then
          xi = xlow+dfloat(ix0-1)*hx
          yj = ylow+dfloat(jy0-1)*hy
          p1(1,1) = xi
          p1(1,2) = yj
          p1(2,1) = xi
          p1(2,2) = yj+hy
          p1(3,1) = xi+hx
          p1(3,2) = yj+hy
          p1(4,1) = xi+hx
          p1(4,2) = yj
          p1(5,1) = xi
          p1(5,2) = yj
          p1(6,1) = -99.d0
          p1(6,2) = -99.d0 
c
          call poin2d(pwave,p1,dummy,area)
          vof(ix0,jy0) = vof(ix0,jy0)+area/area0*work
      endif
      return
c
 2    continue
c     # horizontal face:
c     ------------------
c     # compute flow velocity
      call flow(ql,qr,sn,st,meqn,jyrp,iflow,mw0)
c
c     # for numerical stability
      if (dabs(sn) .le. tol) return
c
      ddy = sn*dt
      ddx = st*dt
c
      if (sn .gt. 0.d0) then
          jy0 = j
          idir = -1
          work = -work
      else
          jy0 = j-1
          idir = 1
      endif
c
c     # construct wave polygon (going clockwise)
      call mkpowv(pwave,x1,y1,x2,y2,ddx,ddy,idir,1)
c
c     # construct grid polygon
      xi = xlow+dfloat(i-1)*hx
      yj = ylow+dfloat(jy0-1)*hy
      p1(1,1) = xi
      p1(1,2) = yj
      p1(2,1) = xi
      p1(2,2) = yj+hy
      p1(3,1) = xi+hx
      p1(3,2) = yj+hy
      p1(4,1) = xi+hx
      p1(4,2) = yj
      p1(5,1) = xi
      p1(5,2) = yj
      p1(6,1) = -99.d0
      p1(6,2) = -99.d0
c
      call poin2d(pwave,p1,dummy,area) 
      vof(i,jy0) = vof(i,jy0)+area/area0*work
c
      if (ddx .gt. 0.d0) then
          ix0 = i+1
      else
          ix0 = i-1
      endif
c
      if ((ix0 .ge. 1) .and. (ix0 .le. mitot)) then
          xi = xlow+dfloat(ix0-1)*hx
          yj = ylow+dfloat(jy0-1)*hy
          p1(1,1) = xi
          p1(1,2) = yj
          p1(2,1) = xi
          p1(2,2) = yj+hy
          p1(3,1) = xi+hx
          p1(3,2) = yj+hy
          p1(4,1) = xi+hx
          p1(4,2) = yj
          p1(5,1) = xi
          p1(5,2) = yj
          p1(6,1) = -99.d0
          p1(6,2) = -99.d0
c
          call poin2d(pwave,p1,dummy,area)
          vof(ix0,jy0) = vof(ix0,jy0)+area/area0*work
      endif
      return
c
      end
