function plot2d(nvar,m,ichoice,jchoice,logp)
clf
fid = fopen('fort.51');
info = fscanf(fid,'%d %d %d %g %g %g %g',8);
status = fclose(fid);
%
mitot = info(1);
mjtot = info(2);
ix1 = info(3)+1;
ixn = mitot-info(3);
jy1 = info(3)+1;
jyn = mjtot-info(3);
xcorn = info(4);
ycorn = info(5);
hx = info(6);
hy = info(7);
meqn = info(8);
nrow = jyn-jy1+1;
ncol = ixn-ix1+1;
x = xcorn+(0:ncol)*hx;
y = ycorn+(0:nrow)*hy;
xmin = min(x);
ymin = min(y);
xmax = max(x);
ymax = max(y);
%xlim([xmin xmax])
%ylim([ymin ymax])
%
fid = fopen('plot.3');
data = fscanf(fid,'%g',[nvar nrow*ncol]);
data = data';
status = fclose(fid);
%
q = reshape(data(:,m),nrow,ncol);
qaug = ones(nrow+1,ncol+1);
qaug(1:nrow,1:ncol) = q;
qaug(1:nrow,ncol+1) = q(:,ncol);
qaug(nrow+1,1:ncol) = q(nrow,:);
qaug(nrow+1,ncol+1) = q(nrow,ncol);
%
if logp == 1
    qaug = log(qaug);
end
qmin = 1e6;
qmax = -1e6;
qmin = min(qmin,min(min(qaug)));
qmax = max(qmax,max(max(qaug)));
%
if jchoice == 1
   fid = fopen('fort.73');
   npts = fscanf(fid,'%d',[1 inf]);
   npts = npts';
   status = fclose(fid);
   nsum = length(npts);
%
   fid = fopen('fort.71');
   data1 = fscanf(fid,'%g',[nvar inf]);
   data1 = data1';
   status = fclose(fid);
   qirr = data1(:,m);
%
   fid = fopen('fort.72');
   poly = fscanf(fid,'%g %g',[2 inf]);
   poly = poly';
   status = fclose(fid);
%
   fid = fopen('fort.12');
   front = fscanf(fid,'%g %g %g %g',[4 inf]);
   status = fclose(fid);
   front = front';
%
   qmin = min(qmin,min(min(qirr)));
   qmax = max(qmax,max(max(qirr)));
end
%
if ichoice == 1
   x1 = x(1);
   x2 = x(ncol+1);
   y1 = y(1);
   y2 = y(nrow+1);
%
   clf
   plot([x1,x1,x2,x2,x1], [y1,y2,y2,y1,y1], 'red');
   axis off;
   hold on
   contour(x,y,qaug,30);
%
   if jchoice == 1
      plot(front(:,1),front(:,2), 'red')
      plot(front(:,3),front(:,4), 'red')
   end
   hold off
elseif ichoice == 2
   pcolor(x,y,qaug);
   yrbcolormap;
%   colormap('default');
   shading('interp');
%   shading flat;
%   yrbcolormap;
%   caxis('auto');
   caxis([qmin qmax]);
   colorbar;
%
   if jchoice == 1
      hold on
      na = 1;
      for k=1:nsum
          nb = na+npts(k)-1;
          patch(poly(na:nb,1),poly(na:nb,2),qirr(k))
          na = nb+1;
      end
   end
elseif ichoice == 3
      % for Schlieren plot, we compute gradient  (following Quirk)
      [Ax,Ay] = gradient(qaug,hx,hy);
      qaug = sqrt(Ax.*Ax + Ay.*Ay);
      phandle = pcolor(x,y,qaug);
      shading('flat');
      colormap(flipud(gray(2048)).^20)
elseif ichoice == 4 
   surfl(x,y,qaug);
elseif ichoice == 5
   contour3(x,y,qaug,30);
elseif ichoice == 6
   meshc(x,y,qaug);
else
   meshc(x,y,-qaug);
end
%
format long;
qrange = [qmin,qmax]
axis image
%axis('square')
